::xo::library doc {
    TLF XoSyllabus
    @author Markus Moser
    @creation-date 2011-03-02
}

##::xo::db::require package xowf
::xo::library require -package xowf xowf-procs
::xo::library require -package xowiki form-field-procs


namespace eval ::xowiki::formfield {
    Class create subst_label -superclass label

    subst_label instproc render_input {} {
        if {${:value} eq "passed"} {
            set :value [lang::message::lookup [::xo::cc set locale] tlf-assignments.passed ""]
        } elseif {${:value} eq "not passed"} {
            set :value [lang::message::lookup [::xo::cc set locale] tlf-assignments.not_passed ""]
        }
        next
    }
}

namespace eval ::xowiki::formfield {
    ###
    ### opentext_sample
    ### OT sample solutions
    ###
    Class create opentext_compound -superclass FormGeneratorField -parameter {
    }

    opentext_compound instproc initialize {} {
        :create_components  [subst {
            {opentext_sample {opentext_sample,repeat=3..10,label=}}
        }]
        set :__initialized 1
    }


    Class create opentext_sample -superclass FormGeneratorField -parameter {}

    opentext_sample instproc initialize {} {
        if {${:__state} ne "after_specs"} {
            return
        }
        :instvar input_field_names
        :create_components  {
            {solution {richtext,label=#tlf-assignments.other_rating#,editor=ckeditor4,\
			   customConfig=/resources/tlf-assignments/ck_config_minimal.js,\
			   toolbar=Minimal}}
            {qvar {scale,horizontal=true,default=3,label=#tlf-assignments.qvar#,n=10}}
        }
        regexp {opentext_sample.opentext_sample.(\d*)} ${:name} match nr
        set :nr $nr
        set :__initialized 1
    }

    opentext_sample instproc check=valid {value} {
        uplevel 1 [list set __langPkg "tlf-assignments"]
        set exercise_form [${:object} get_property -name exercise_form]
        if {$exercise_form eq "ot"} {
            set answer [:get_named_sub_component_value solution]
            if {$answer eq ""} {
                # util_user_message -message "Alle drei Antwortfelder müssen befüllt sein."
                return 0
            }
            set qvar [:get_named_sub_component_value qvar]
            if {![string is integer $qvar]} {
                #util_user_message -message "Qualitätswert muss eine ganze Zahl sein"
                return 0
            }
            if {$qvar > 10 || $qvar < 1} {
                #util_user_message -message "Qualitätswert muss zwischen 1 und 10 liegen"
                return 0
            }
        }
        return 1
    }

    opentext_sample instproc convert_to_internal {} {
        :instvar nr
        set package_id [${:object} package_id]
        #create sample solutions
        set answer [:get_named_sub_component_value solution]
        set x ${:nr}
        if {$answer ne ""} {
            set qvar [expr {[:get_named_sub_component_value qvar]/10.0}]
            set template [string trimleft [
                                           $package_id resolve_page abgabe-stud.wf method_var] :]
            set existing_page [
                               $package_id resolve_page_name [${:object} set name]___$x]
            if {$existing_page eq ""} {
                ::xowiki::FormPage create solution -noinit \
                    -set instance_attributes [subst {
                        exercise_form ot assignment_id [
                                                        list [${:object} set item_id]]
                        answer [list $answer] qvar [list $qvar]
                        bvar [list $qvar] is_sample 1
                    }]	\
                    -set text {} \
                    -set state {graded} \
                    -set page_template $template \
                    -set package_id $package_id \
                    -set name [${:object} set name]___$x \
                    -set title {Opentext Exercise} \
                    -set publish_status ready \
                    -set parent_id [$package_id set folder_id]
                solution save_new
            } else {
                #update
                $existing_page set_property qvar $qvar
                $existing_page set_property bvar $qvar
                $existing_page set_property answer $answer
                $existing_page set_property is_sample 1
                $existing_page save
            }
        }
    }
}
namespace eval ::xowiki::formfield {
    Class create pretty_file -superclass file -parameter {
        {size 40}
        {plagcheck 1}
        {resub 0}
	{viruscheck false}
        link_label
    }
    #resub: if this is set to true, the current content of the formfield will not be displayed

    pretty_file instproc render_input {} {
        :instvar value content-type resub plagcheck
        set package_id [${:object} package_id]
        array set entry_info [:entry_info]
        set file_item [[$package_id] lookup -parent_id [${:object} item_id] -name file:${:name}]
        set :required false
        next
        set amiadmin [expr {[permission::permission_p -object_id $package_id -privilege "admin"] && [${:object} set state] ne "graded"}]
        set register_me 1

        if {$resub} {
            set nonce [security::csp::nonce]
            ::html::t -disableOutputEscaping "
               <script type='text/javascript' nonce='$nonce'>
                 \$('#__a__old_value_${:name}').hide();
                 \$('#__old_value_${:name}').val('');
               </script>"
        }
    }

    pretty_file instproc check=files_not_empty {value} {
        uplevel 1 [list set __langPkg "tlf-assignments"]
        set file_found 0
        for {set i 1} {$i <= 5} {incr i} {
            set file [${:object} lookup_cached_form_field -name file$i]
            set file_item [${:object} get_property -name file:file$i]
            if {[$file value] ne "" || $file_item ne ""} {
                set file_found 1
                break
            }
        }
        return $file_found
    }
}

namespace eval ::xowiki::formfield {
    Class create date_with_widget -superclass date
    date_with_widget instproc initialize {} {
        ::xo::Page requireJS "/resources/tlf-assignments/tlf-assignment.js"
        set :widget_type date
        set :format [string map [list _ " "] ${:format}]
        array set :defaults {year 2000 month 01 day 01 hour 00 min 00 sec 00}
        array set :format_map {
            SS    {SS    %S 1}
            MI    {MI    %M 1}
            HH24  {HH24  %H 1}
            DD    {DD    %e 0}
            MM    {MM    %m 1}
            MON   {mon   %m 1}
            MONTH {month %m 1}
            YYYY  {YYYY  %Y 0}
        }
        foreach c ${:components} {
            $c destroy
        }
        :components [list]

        foreach element [split ${:format}] {
            lassign [set :format_map($element)] class code trim_zeros
            #
            # create for each component a form field
            #
            set name $class
            set c [::xowiki::formfield::$class create [self]::$name \
                       -name ${:name}.$name -id ${:id}.$name \
                       -locale ${:locale} -object ${:object}]
            [self]::$name set required 1
            if {$name eq "YYYY"} {
                [self]::$name set value [clock format [clock seconds] -format %Y]
            }
            if {$name eq "month"} {
                set stripped_mon [string trimleft [clock format [clock seconds] -format %m] 0]
                [self]::$name set value $stripped_mon
            }
            if {$name eq "DD"} {
                [self]::$name set value [clock format [clock seconds] -format %e]
            }
            if {$name eq "HH24"} {
                [self]::$name set value [clock format [clock seconds] -format %H]
            }
            if {$name eq "MI"} {
                [self]::$name set value 0
            }

            $c set_disabled [info exists :disabled]
            $c set code $code
            $c set trim_zeros $trim_zeros
            if {$c ni ${:components}} {lappend :components $c}
        }
    }

    date_with_widget instproc check=time_to {value} {
        uplevel 1 [list set __langPkg "tlf-assignments"]
        set time_from [${:object} lookup_cached_form_field -name time_from]
        set time_from [clock scan [$time_from get_compound_value]]
        set time_to [clock scan [:get_compound_value]]
        if {$time_from >= $time_to} {
            # util_user_message -message "Enddatum muss nach Startdatum liegen"
            return 0
        }
        return 1
    }

    date_with_widget instproc check=release_date {value} {
        uplevel 1 [list set __langPkg "tlf-assignments"]
        set freigabe [${:object} lookup_cached_form_field -name beurteilung]
        if {[$freigabe set value] ne "date"} {
            return 1
        }
        set release_date [clock scan [:get_compound_value]]
        if {[clock seconds] > $release_date} {
            # util_user_message -message "Freigabedatum muss in der Zukunft liegen"
            return 0
        }
        return 1
    }

    date_with_widget instproc value {args} {
        if {[llength $args] == 0} {
            set v [:get_compound_value]
            #my msg "${:name}: reading compound value => '$v'"
            return $v
        } else {
            #my msg "${:name}: setting compound value => '[lindex $args 0]'"
            :set_compound_value [lindex $args 0]
            set :value [lindex $args 0]
        }
    }

    date_with_widget instproc check=check_resubmission {value} {
        uplevel 1 [list set __langPkg "tlf-assignments"]
        set ast [${:object} get_property -name assignment_id]
        ::xo::db::CrClass get_instance_from_db -item_id $ast
        set resub_time [clock scan [:get_compound_value]]
        if {[clock seconds] > $resub_time} {
            # util_user_message -message "Überarbeitungsfrist muss in der Zukunft liegen."
            return 0
        }
        return 1
    }

    date_with_widget instproc render_input {} {
        set id "F.[${:object} name].${:name}"
        set button_id cal_item.$id
        ::html::input -id $button_id -type button -style "height:23px; width:23px; background: url('/resources/acs-templating/calendar.gif');"
        template::add_event_listener -id $button_id -script [subst {return showWikiCalendarWithDateWidget('$id', 'y-m-d');}]
        next
    }

    date_with_widget instproc validate {obj} {
        #compound fields ignore if a validator is defined for them and try to validate each of their components
        :instvar name required
        # use the 'value' method to deal e.g. with compound fields
        set value [:value]
        foreach validator ${:validator} {
            set errorMsg ""
            #
            # The validator might set the variable errorMsg in this scope.
            #
            set success 1
            set validator_method check=$validator
            set proc_info [:procsearch $validator_method]
            #my msg "++ ${:name}: field-level validator exists '$validator_method' ? [expr {$proc_info ne {}}]"
            if {$proc_info ne ""} {
                # we have a slot checker, call it
                #my msg "++ call-field level validator $validator_method '$value'"
                set success [:validation_check $validator_method $value]
            }
            if {$success == 1} {
                # the previous check was ok, check now for a validator on the
                # object level
                set validator_method validate=$validator
                set proc_info [$obj procsearch $validator_method]
                #my msg "++ ${:name}: page-level validator exists ? [expr {$proc_info ne {}}]"
                if {$proc_info ne ""} {
                    set success [$obj $validator_method $value]
                    #my msg "++ call page-level validator $validator_method '$value' returns $success"
                }
            }
            if {$success == 0} {
                #
                # We have an error message. Get the class name from procsearch and construct
                # a message key based on the class and the name of the validator.
                #
                set cl [namespace tail [lindex $proc_info 0]]
                #my msg "__langPkg?[info exists __langPkg]"
                if {![info exists __langPkg]} {set __langPkg "xowiki"}
                return [_ $__langPkg.$cl-validate_$validator [list value $value errorMsg $errorMsg]]
                #return [::lang::message::lookup "" xowiki.$cl-validate_$validator %errorMsg% [list value $value errorMsg $errorMsg] 1]
            }
        }
        return ""
    }
}

namespace eval ::xowiki::formfield {
    textarea instproc check=safe_html {value} {
        set msg [ad_html_security_check $value]
        if {$msg ne ""} {
            :uplevel 1 [list set errorMsg $msg]
            return 0
        }
        return 1
    }
}

namespace eval ::xowiki::formfield {
    #generic validation for submission types
    FormField instproc check=grading_validator {value} {
        uplevel 1 [list set __langPkg "tlf-assignments"]
        set ast [${:object} get_property -name assignment_id]
        set grading_type [$ast get_property -name modus]
        set maxpoints [$ast get_property -name points]
        ds_comment "doing a grade validation check for $grading_type"
        GradingType=${grading_type} create [self]::gtype
        if {$grading_type eq "points"} {
            return [[self]::gtype validateInput [list $value $maxpoints]]
        } else {
            return [[self]::gtype validateInput [list $value]]
        }
    }
}

namespace eval ::xowiki::formfield {
    #generic validation for submission types
    Class create composite_selector -superclass form_page  -parameter {}

    composite_selector instproc initialize {} {
        :instvar form_object_item_ids package_id object scope parent_id
        next
        set package_id [$object package_id]
        set pt [$package_id resolve_page create-assignment.wf method_var]
        if {$pt eq ""} {
            error "could not find create-assignment wf. make sure it is in the package path"
        }
        set form_object_item_ids [$pt set item_id]

        if {$form_object_item_ids eq ""} {
            error "Cannot lookup Form 'assignment_wf'"
        }
        :msg "done with init"
    }

    composite_selector instproc render_input {} {
        next
    }

    label instproc check=no_groups {value} {
           uplevel 1 [list set __langPkg "tlf-assignments"]   
        set groups [[${:object} lookup_cached_form_field -name zuweisen] value]
        if {$groups eq "gruppe"} {
            return 0
        }
        return 1
    }

    label instproc check=no_members {value} {
        uplevel 1 [list set __langPkg "tlf-assignments"]
        set groups [[${:object} lookup_cached_form_field -name zuweisen] value]
        if {$groups eq "einzelne"} {
            return 0
        }
        return 1
    }
}

namespace eval ::xowiki::formfield {

    Class create points -superclass text

    points instproc initialize {} {
        next
    }

    points instproc convert_to_internal {} {
        if {[set value [:value]] ne ""} {
            if {[lc_get "decimal_point"] eq ","} {
                regsub "," $value "." value
            }
            ${:object} set_property -new 1 ${:name} [expr {$value}]
            return
        }
    }
}

namespace eval ::xowiki::formfield {

    Class create labeled_scale -superclass radio -parameter {{n 5} {horizontal true} {labels ""}}

    labeled_scale instproc initialize {} {
        :instvar n
        set labels ${:labels}
        set options [list]
        for {set i 1} {$i <= $n} {incr i} {
            lappend options [list [lindex $labels $i-1] $i]
        }
        :options $options
        next
    }
}

namespace eval ::xowiki::formfield {
    ###########################################################
    #
    # ::xowiki::formfield::candidate_box_select_jquery
    #
    ###########################################################
    Class create candidate_box_select_jquery -superclass select -parameter {
        {role ""}
    }
    candidate_box_select_jquery instproc render_input {} {
        ::xo::Page requireJS "/resources/xowiki/jquery/jquery-ui.js"
        :instvar role
        if {$role ne ""} {
            set object_id [::xo::role::$role get_object_id ${:object}]
            set :options [::xo::role::$role get_members -object_id $object_id]
        }
        set id ${:name}
        ::html::br
        ::html::div -class "candidate-selection col-md-4" {
            ::html::div -class "workarea selected col-md-4" {
                ::html::h4 { ::html::t "#tlf-assignments.current_sel#"}
                ::html::ul -id ${id}_selection -class {region selected} {
                    foreach o [:value] {
                        set object_type [acs_object_type $o]
                        if {$object_type eq "user"} {
                            set label [::xo::dc get_value get_info "select last_name || ', ' || first_names || '; ' || username as title FROM acs_users_all  where user_id = :o"]
                        } elseif {$object_type eq "group"} {
                            group::get -group_id $o -array group_info
                            set label $group_info(group_name)
                        }
                        ::html::li -data-uid $o -class {candidates list-group-item} {::html::t $label}
                    }
                }
            }
            ::html::div -class "col-md-4" {
                ::html::div -class "workarea candidate-selection col-md-4" {
                    ::html::h4 { ::html::t "#tlf-assignments.selections#"}
                    ::html::ul -id ${id}_candidates -class region {
                        foreach o ${:options} {
                            lassign $o label rep
                            if {$rep ni ${:value}} {
                                ::html::li -data-uid $rep -class {list-group-item candidates} {::html::t $label}
                            }
                        }
                    }
                }
            }
        }
        #helper stuff
        set :style "display:none;"
        ::html::textarea [:get_attributes id name cols rows style {CSSclass class}] {
            ::html::t [:value]
        }
        #register sortable widget
        set js "
        \$(document).ready(function() {
            \$('#${id}_candidates').sortable({
                connectWith: '#${id}_selection'
            });
            \$('#${id}_selection').sortable({
                connectWith: '#${id}_candidates',
                update: function(event, ui) {
                    var txtareastring = '';
                    \$('#${id}_selection li').each(function(i,e) {
                        txtareastring+=e.getAttribute('data-uid')+' ';
                    });
                    \$('textarea\[name=${:name}\]').val(txtareastring);
                }
            });
            if (\$('#groups_candidates > li').length == 0) {
                \$('#group_conditional > div').hide();
            };
            if (\$('#bearbeiter_candidates > li').length == 0) {
                \$('#member_conditional > div').hide();
            };

        });
        "
        ::html::script -nonce [security::csp::nonce] { html::t $js}
    }

    candidate_box_select_jquery instproc check=options {value} {
        #skip validation for this legacy field
        return 1
    }
}

namespace eval ::xowiki::formfield {
    
    Class create conditional_ff -superclass select -parameter {
        {condition name}
        {condition_label ""}
        onselection
    } -ad_doc {
        Conditional_ff from assignments-core
    }

    conditional_ff instproc render_input {} {
        set atts [:get_attributes id name {CSSclass class}]
        set disabled_p [:is_disabled]
        if {$disabled_p} {lappend atts disabled true}
        if {[:multiple]} {
            lappend atts multiple [:multiple]
        }
        set options [:options]
        if {![:required]} {
            set options [linsert $options 0 [list "--" ""]]
        }

        set html_id [lindex [:get_attributes id] 1]
        template::add_event_listener -event change -id $html_id -script [subst {
            conditional_unhide('$html_id','${:condition}','${:onselection}');
        }]

        ::html::select $atts {
            foreach o $options {
                lassign $o label rep
                set atts {}
                if {$disabled_p} {
                    lappend atts disabled true
                }
                lappend atts value $rep
                #:msg "lsearch {[:value]} $rep ==> [lsearch [:value] $rep]"
                if {$rep in [:value]} {
                    lappend atts selected on
                }
                ::html::option $atts {::html::t $label}
                ::html::t \n
            }
        }
    }

    #legacy validator from tlf-assignment
    conditional_ff instproc check=members_valid {value} -returns boolean {
        uplevel 1 [list set __langPkg "tlf-assignments"]
        switch $value {
            einzelne {
                if {[[${:object} lookup_cached_form_field -name bearbeiter] value] eq ""} {
                    return 0
                }
            }
            gruppe {
                if {[[${:object} lookup_cached_form_field -name groups] value] eq ""} {
                    return 0
                }
            }
        }
        return 1
    }
}
::xo::library source_dependent
