namespace eval ::xowiki::includelet {
#simple group manager
#author: marmoser
#creation date: 05/07/2011

::xowiki::IncludeletClass create tlf_groupmgr \
    -superclass ::xowiki::Includelet \
    -parameter {
        {__decoration none}
    }

    tlf_groupmgr instproc group_assign {
        -group_id:integer,required
        -members:required
        {-rel_type membership_rel}
        {-member_state ""}
    } {
        set package_id [::xo::cc set package_id]
        set folder [$package_id set folder_id]
        set template [$package_id lookup -name create-assignment.wf]
        set old_members [group::get_members -group_id $group_id]
        foreach m $members {
            if {$m ni $old_members} {
                group::add_member -group_id $group_id -user_id $m \
                    -rel_type $rel_type -member_state $member_state
            }
        }
        foreach m $old_members {
            if {$m ni $members} {
                group::remove_member -group_id $group_id -user_id $m
            }
        }
        set package_id [::xo::cc package_id]
        #update gb_party_map
        ns_log notice "tlf_groupmgr: update party_map"
        foreach gb_entry [::xo::dc list affected_gb_entries "select gb_entry_id
            from xowiki_form_instance_item_index x join gb_entry g on (g.source_key::integer = x.item_id)
            and g.source_package = :package_id and :group_id in (
                select regexp_split_to_table( (
                    select regexp_replace( hkey->'groups',  E'\\r', '','g'))
                    , E'\\\\s')::integer
                )"] {
            ns_log notice "tlf_groupmgr: gb_entry $gb_entry"
            # insert into gb_party_map every group member that is not
            # in there already
            ::xo::dc dml update_gb_party_map {
                insert into gb_party_map 
                    select m.gb_entry_id, ga.member_id as party_id
                      from group_member_map ga, 
                           gb_party_map m
                     where group_id = :group_id 
                       and m.gb_entry_id = :gb_entry
                       and ga.member_id != m.party_id
            }
        }
    }

    tlf_groupmgr instproc render {} {
        set nonce [expr {[info exists ::__csp_nonce] ? "nonce=\"$::__csp_nonce\"" : ""}]
        set amiswa [acs_user::site_wide_admin_p -user_id [::xo::cc user_id]]
        set package_id [::xo::cc set package_id]
        ::xo::Page requireCSS /resources/tlf-assignments/tlf-assignments.css
        set ajaxhelper 0
        ::xo::Page requireJS urn:ad:js:jquery
        ::xo::Page requireJS "/resources/xowiki/jquery/jquery-ui.js"
        ::xo::Page requireJS "/resources/tlf-assignments/tlf-assignment.js"
        ::xo::Page requireJS "
        function create_group(id, uri) {
            var selected_users = \$(\"#users li\").map(function(i,e) {
                return e.getAttribute('data-uid');
            }).get().join(',');
            var groupname = \$(\"#groupname\").val();
            if (groupname == '') { alert('[_ tlf-assignments.group_name_empty]'); return false; }
            var xocc = '[::xo::cc set url]';
            \$.ajax({
                url: xocc+'?a=create-group',
                type: 'POST',
                async: false,
                data: 'selected='+selected_users+'&id='+id+'&name='+groupname,
                complete: function(data) {
                    location.replace(xocc);
                },
                error : function(data) {
                    console.debug('error');
                }
            });
        }"
        set html ""
#        ::xo::Page set_property doc menubar [[::xo::cc package_id] MenuBar]
        set action [::xo::cc query_parameter a]
        set current [::xo::cc query_parameter id]
        set comm_id [dotlrn_community::get_community_id]
        set gname groupmgr_${comm_id}
        set group_list [::xo::dc list groups "select group_id, group_name from groups where description = :gname"]
        if {$current ne "" && $current ni $group_list} {
            error "Invalid group ID"
            ad_script_abort
        }
        if {$action eq "create-group"} {
            set selected [ns_queryget selected]
            set group_id [ns_queryget id]
            set group_name [ns_queryget name]
            if {$group_name eq ""} {
                return
            }
            if {$group_id eq ""} {
                set group_id [group::new -group_name $group_name]
            }
            array set gr [subst {description groupmgr_${comm_id} group_name "$group_name"}]
            group::update -group_id $group_id -array gr
            :group_assign -group_id $group_id -members [split $selected ,]
        }
        if {$action eq "view_detail"} {
            set group_id [ns_queryget id]
            group::get -group_id $group_id -array group_info
            append html "<h2>[_ tlf-assignments.group_memb]  $group_info(group_name)</h2>"
            foreach member [group::get_members -group_id $group_id] {
                ::xo::dc foreach comm_id1 "select community_id as c_id from dotlrn_community_applets
                    where package_id = :package_id" {
                    #if {[dotlrn_community::get_member_role $c_id $member] ne ""} 0{
                        append html [::tlf_cassignments::get_user_name -user_id $member]<br>
                    #}
                }
            }
            append html "<br><a class='button' href='[ns_queryget return_url]'>Zurück</a>
            <a class='button' href='groupmgr?a=edit&id=$group_id'>[_ xowiki.edit]</a>"
            return $html
        }
        if {$action eq "edit"} {
            #edit a group
            ::xo::Page requireCSS "/resources/tlf-assignments/tlf-assignments.css"
            group::get -group_id $current -array group_info
            append html "<h3>[_ tlf-assignments.group_edit]: $group_info(group_name)</h3>"
            set allmembers [::xo::role::tlf_ast_group_stud get_members -object_id $comm_id]
            set members [group::get_members -group_id $current]
            set selected ""
            set candidates ""
            set js ""
            foreach {member} $allmembers {
                foreach {name id} $member {
                    set js_label  [::xowiki::Includelet js_encode $name]
                    set js_rep [::xowiki::Includelet js_encode $id]
                    if {$id in $members} {
                        append selected "<li class='candidates list-group-item' data-uid='$id'>$js_label</li>"
                    } else {
                        append candidates "<li class='candidates list-group-item' data-uid='$id'>$js_label</li>"
                    }
                }
            }
            append js {
                $(document).ready(function() {
                    $( "#users_candidates").sortable({
                         connectWith: ".region"
                    });
                    $( "#users").sortable({
                        connectWith: ".region"
                    });
                })
            }
            set save_html_id "create-group-${current}"
            append html "
            <div class='row form-shading'>
                <div class='col-md-4'>
                    <h4>[_ tlf-assignments.group_name]</h4>
                    <input type='text' id='groupname' value='$group_info(group_name)' style='width:100%;'>
                </div>
                <div class='col-md-4 candidate-selection'>
                    <h4>[_ tlf-assignments.current_sel]</h4>
                     <ul class='region selected' name='users' id='users'>$selected</ul>
                </div>
                <div class='col-md-4'>
                    <div class='candidate-selection'>
                        <h4>[_ tlf-assignments.selections]</h4>
                        <div>
                            <ul class='region' id='users_candidates'>
                                $candidates
                            </ul>
                        </div>
                    </div>
                </div>
            </div>
            <div style='margin-top:1em;'><a id=\"${save_html_id}\" class='button' href=\"#\">[_ tlf-assignments.save_edit]</a></div>
            <script type='text/javascript' $nonce>
              $js
              var e = document.getElementById('${save_html_id}');
              e.addEventListener('click', function (event) {create_group('$current');}, false);
            </script>
            "
            return $html
        } elseif {$action eq "delete"} {
            set package_id [::xo::cc set package_id]
            #delete a group
            #select assignments with this group
            set folder [$package_id set folder_id]
            set template [$package_id lookup -name create-assignment.wf]
            set refs [::xo::dc list referenced_assignments "select item_id
                FROM xowiki_form_instance_item_index bt
                WHERE page_template IN (:template)
                AND publish_status='ready'
                AND parent_id = :folder
                AND :current::varchar = any(string_to_array((hkey->'groups')::text,' '))
                ORDER BY name DESC"]
            if {$refs ne ""} {
                append html "[_ tlf-assignments.references]<br>"
                foreach item $refs {
                    ::xo::db::CrClass get_instance_from_db -item_id $item
                    append html "<a href='[$item pretty_link]'>[$item set title] </a><br><br>"
                }
            } else {
                group::delete $current
            }
        } elseif {$action eq "neu"} {
            append html "<h3>[_ tlf-assignments.group_new]</h3>"
            set allmembers [::xo::role::tlf_ast_group_stud get_members -object_id $comm_id]
            set candidates ""
            foreach {member} $allmembers {
                foreach {name id} $member {
                    set js_label  [::xowiki::Includelet js_encode $name]
                    append candidates "<li class='candidates list-group-item' data-uid='$id'>$js_label</li>"
                }
            }
            if {$candidates eq ""} {
                set field_display "display:none;"
                set text_display ""
            } else {
                set field_display ""
                set text_display "display:none;"
            }
            append js {
                $(document).ready(function() {
                    $( "#users_candidates").sortable({
                         connectWith: ".region"
                    });
                    $( "#users").sortable({
                        connectWith: ".region"
                    });
                })
            }
            append html "
            <div class='row form-shading'>
                <div class='col-md-4'>
                    <h4>[_ tlf-assignments.group_name]</h4>
                    <input type='text' id='groupname' style='width:100%;'>
                </div>
                <div class='col-md-4 candidate-selection'>
                    <div class='workarea selected'>
                        <h4>[_ tlf-assignments.current_sel]</h4>
                        <ul class='region selected' name='users' id='users'>
                    </ul>
                    </div>
                </div>
                <div class='col-md-4'>
                    <div>
                        <h4>[_ tlf-assignments.selections]</h4>
                        <div style='$text_display'>[_ tlf-assignments.empty_com]</div>
                        <div class='candidate-selection' style='$field_display'>
                            <ul class='region' id='users_candidates'>
                                $candidates
                            </ul>
                        </div>
                        </div>
                   </div>
                </div>
                <div class='form-help-text' style='$field_display'>
                    <img width='12' height='9' border='0' style='margin-right:5px' title='Help text' alt='Help text' src='/shared/images/info.gif'>[_ tlf-assignments.group_help]
                </div>
                <div style='margin-top:1em;'><a id=\"create-group-button\" class='button' href=\"#\">[_ tlf-assignments.group_create]</a></div>
                <script type='text/javascript' $nonce>
                   $js
                   var e = document.getElementById('create-group-button');
                   e.addEventListener('click', function (event) {create_group('');}, false);
                </script>"
            return $html
        }
        #list all existing groups
        set csv ""
        append html "
                     <table class='list-table'>
                     <caption>[_ tlf-assignments.comm_groups]</caption>
                     <tr><th>[_ tlf-assignments.group_name]</th>
                     <th>[_ tlf-assignments.group_memb]</th>
                     <th>[_ tlf-assignments.actions]</th>"
        append html "</tr>"
        set gname groupmgr_${comm_id}
        ::xo::dc foreach gr "select group_id, group_name from groups where description = :gname" {
            append html "<tr><td>$group_name</td><td>"
            foreach member [group::get_members -group_id $group_id] {
                ::xo::dc foreach comm_id2 "select community_id as c_id from dotlrn_community_applets
                where package_id = :package_id" {
                    #if {[dotlrn_community::get_member_role $c_id $member] ne ""} {
                        if {$action eq "export"} {
                            acs_user::get -user_id $member -array user_info
                            append csv "$group_name; $user_info(username);  $user_info(last_name); $user_info(first_names)\n"
                            array unset user_info
                        }
                        append html [subst {<a href="/shared/community-member?user_id=$member">[::tlf_cassignments::get_user_name -user_id $member]</a><br>}]
                    #}
                }
            }
            append html "
               </td>
               <td>
                  <a href='[::xo::cc set url]?a=edit&id=$group_id' alt='bearbeiten'>
                     <img src='/resources/tlf-assignments/images/icons_famfamfam/page_white_edit.png'>
                  </a>&nbsp;
                  <a class='tlf-assignments.del_conf' href='[::xo::cc set url]?a=delete&id=$group_id' alt='löschen'>
                     <img src='/resources/tlf-assignments/images/icons_famfamfam/bin_empty.png'>
                  </a>
               </td>"
            append html "</tr>"
        }
        append html "
        <script type='text/javascript' $nonce>
            var elems = document.getElementsByClassName('tlf-assignments.del_conf');
            for (var i = 0, l = elems.length; i < l; i++) {
               elems\[i\].addEventListener('click', function (event) {
                  if (!confirm('[_ tlf-assignments.del_conf]')) {
                     event.preventDefault();
                  }
               }, false);
            }
        </script>"
        if {$csv ne ""} {
            ns_set update [ns_conn outputheaders] content-disposition [subst {attachment; filename="[dotlrn_community::get_community_shortname $comm_id]_[dotlrn_community::get_community_name  $comm_id].csv"}]
            ns_return 200 text/csv $csv
            ad_script_abort
        }
        append html "</table>
                        <a href='groupmgr?a=neu'>[_ tlf-assignments.group_new]</a>"
        return $html
    }
}

namespace eval ::tlf_groupmgr {

    ad_proc -private ::tlf_groupmgr::remove_user_from_community {
        community_id
        user_id
    } {
        remove user from groups in this community
    } {
        set gname groupmgr_${community_id}
        ::xo::dc transaction {
            ::xo::dc foreach gr "select group_id, group_name from groups where description = :gname" {
                if {[group::member_p -user_id $user_id -group_id $group_id]} {
                    group::remove_member -group_id $group_id -user_id $user_id
                    ns_log notice "remove_user_from_community removed $user_id from $group_id"
                }
            }
        }
    }
}
