::xo::library doc {

    Includelet to draw a list of items, adapted from podcasting
    package

}

namespace eval ::xowiki::includelet {

    ::xowiki::IncludeletClass create tlf_assignment_list \
        -superclass ::xowiki::Includelet \
        -parameter {
            {__decoration none}
        }

    tlf_assignment_list instproc render {} {
        # this is our current page, plain and encoded to be put into url queries
        set return_url [::xo::cc set url]?[::xo::cc actual_query]
        set return_url_encoded [ad_urlencode_path [::xo::cc set url]]?[ad_urlencode_query [::xo::cc actual_query]]
        set orderby [::xo::cc query_parameter orderby name,asc]
        ::xo::Page requireCSS "/resources/tlf-assignments/tlf-assignments.css"
        ::xo::Page requireJS "/resources/tlf-assignments/tlf-assignment.js"
        set package_id [${:__including_page} set package_id]
        set community_id [dotlrn_community::get_community_id]
        set amiadmin [permission::permission_p -object_id $package_id -privilege "admin"]
        #overview exercises
        set view [::xo::cc query_parameter view]
        set type [::xo::cc query_parameter type]
        set is_shared 0
        set display_members [parameter::get -package_id [::xo::cc set package_id] \
            -parameter member_display \
            -default 0]
        set substateclause [expr {$amiadmin ? "" : "and state = 'published'"}]
        set assignments [::xowiki::FormPage get_form_entries \
           -base_item_ids [string trimleft [$package_id resolve_page create-assignment.wf method_var] :] \
           -form_fields [list] \
           -always_queried_attributes "_state _description _instance_attributes _creation_date" \
           -package_id $package_id \
           -orderby "state desc, (hkey->'time_to') asc, title asc" \
           -publish_status "ready" \
           -parent_id [$package_id set folder_id] \
           -extra_where_clause $substateclause \
           -from_package_ids "*"]

        ################### PARAMETER 1: LIST OF NOT YET SUBMITTED WORK ######################
        if {$view ne "" && [string is integer -strict $view]} {
            if {![permission::permission_p -object_id $package_id -privilege "admin"] ||
                ![permission::permission_p -object_id $view -privilege "admin"]} {
                ad_returnredirect .
                ad_script_abort
            }
            set ast [::xo::db::CrClass get_instance_from_db -item_id [::xo::cc query_parameter view]]

            if {$type eq "missing"} {
                set bulk_actions [list [_ tlf-assignments.nachfrist_create] [$ast pretty_link] [_ tlf-assignments.nachfrist_create] ]
                set m write_nf
                set op set_nf
                ::template::multirow create tbl_missing matnr name user_id nf item_id
                ::template::list::create \
                    -name "tbl_missing" \
                    -multirow "tbl_missing" \
                    -pass_properties {view type} \
                    -has_checkboxes \
                    -caption [_ tlf-assignments.missing] \
                    -no_data [_ tlf-assignments.no_data]  \
                    -key item_id \
                    -bulk_actions $bulk_actions \
                    -bulk_action_export_vars {m op return_url} \
                        -elements [subst {
                        item_id {
                            label {<input id="tbl_missing.check_all" name="_dummy" title="[_ acs-templating.lt_Checkuncheck_all_rows]" type="checkbox">}
                            html "align=center"
                            sub_class "narrow"
                            display_template {
                                <input type="checkbox" name="item_id" value="@tbl_missing.item_id@" id="tbl_missing.@tbl_missing.item_id@" title="[_ acs-templating.lt_Checkuncheck_this_row]">
                            }
                        }
                        matnr {
                            label "#tlf-assignments.matnr#"
                        }
                        name {
                            label "Name"
                            display_template {
                                <if @tbl_missing.matnr@ eq #tlf-assignments.group#>
                 <a href='groupmgr?id=@tbl_missing.item_id@&a=view_detail&return_url=${return_url_encoded}'>@tbl_missing.name@</a>
                                   <a class='tlf-assignments.del_conf' href='[$view pretty_link]?m=unassign_group&group_id=@tbl_missing.item_id@&return_url=${return_url_encoded}' alt='unassign' title="#tlf-assignments.Group_cancel#">
                                      <img src='/resources/tlf-assignments/images/icons_famfamfam/cancel.png'>
                                   </a>
                                </if>
                                <elseif @tbl_missing.matnr@ eq "undefined">
                                   @tbl_missing.name@
                                </elseif>
                                <else>
                                   <a href='/shared/community-member?user_id=@tbl_missing.user_id@&return_url=${return_url_encoded}'>@tbl_missing.name@</a>
                                   <a href=".?user_details=@tbl_missing.user_id@&return_url=${return_url_encoded}" title="#tlf-assignments.results# @tbl_missing.name@">
                                      <img src='/resources/tlf-assignments/images/icons_famfamfam/zoom_in.png'>
                                   </a>
                                </else>
                            }
                        }
                        nf {
                            label "#tlf-assignments.nachfrist#"
                            display_template {
                               <if @tbl_missing.nf@ ne "">
                                  @tbl_missing.nf@
                                  <a class='bin-empty tlf-assignments.del_conf' href='[$ast pretty_link]?m=write_nf&op=del_nf&item_id=@tbl_missing.item_id@&return_url=${return_url_encoded}' title='#xowiki.delete#'></a>
                               </if>
                            }
                        }
                        submit_for {
                            label "#tlf-assignments.actions#"
                            display_template {
                                <a class='page-white-get' title='#tlf-assignments.submit_for#' href='[$ast pretty_link]?m=submit&user_id=@tbl_missing.user_id@'>&nbsp;</a>
                            }
                        }
                    }] -orderby {
                        matnr {
                            orderby matnr
                        }
                        name {
                            orderby name
                        }
                        nf {
                            orderby nf
                        }
                    }

                template::add_event_listener -id "tbl_missing.check_all" \
                    -script {acs_ListCheckAll('tbl_missing', this.checked);}

                template::add_confirm_handler -CSSclass "tlf-assignments.del_conf" \
                    -message [_ tlf-assignments.del_conf]

                #ds_comment [template::list::orderby_clause -orderby -name "tbl_missing"]
                array set subs [$ast calc_submissions]
                set subm_list [list]
                foreach sub $subs(returnvalue) {
                    ::xo::db::CrClass get_instance_from_db -item_id $sub
                    lappend subm_list [$sub get_property -name group_id]
                }
                append html [$ast render_angabe_full]

                array unset subs
                set bearb [$ast get_property -name bearbeiter]
                set groups [$ast get_property -name groups]
                if {$display_members} {
                    set sql "SELECT
                          p.last_name || ' ' || p.first_names AS name,
                          p.username,
                          p.user_id
                          FROM dotlrn_member_rels_approved dt,
                              acs_users_all p
                          WHERE community_id = :community_id
                             and p.person_id = dt.user_id and dt.rel_type
                                  in ('dotlrn_student_rel','dotlrn_member_rel')
                          ORDER BY p.last_name asc, p.first_names asc;"
                } else {
                    set sql "SELECT
                          p.last_name || ' ' || p.first_names AS name,
                          p.username,
                          p.user_id
                          FROM dotlrn_member_rels_approved dt,
                              acs_users_all p
                          WHERE community_id in
                              (SELECT community_id
                                  FROM dotlrn_community_applets
                                  WHERE package_id=:package_id)
                             and p.person_id = dt.user_id and dt.rel_type
                                  in ('dotlrn_student_rel','dotlrn_member_rel')
                          ORDER BY p.last_name asc, p.first_names asc;"
                }
                if {$bearb eq "" && $groups eq ""} {
                    ::xo::dc foreach member $sql {
                        if {$user_id ni $subm_list} {
                            ::template::multirow append tbl_missing $username $name $user_id [$ast germanize_date ${user_id}_nachfrist] $user_id
                        }
                    }
                } elseif {$groups ne ""} {
                    foreach gr $groups {
                        if {$gr ni $subm_list} {
                            group::get -group_id $gr -array group_info
                            ::template::multirow append tbl_missing #tlf-assignments.group# $group_info(group_name) $gr [$ast germanize_date ${gr}_nachfrist] $gr
                            array unset group_info
                        }
                    }
                } else {
                    set matnr "undefined"
                    #check for single users
                    foreach b $bearb {
                        if {$b ni $subm_list} {
                            set matnr [::xo::dc get_value matnr "select username from acs_users_all where user_id = :b;"]
                            ::template::multirow append tbl_missing $matnr [::tlf_cassignments::get_user_name -user_id $b] $b [$ast germanize_date ${b}_nachfrist] $b
                        }
                    }
                }
                set sort [split $orderby ,]
                if {$sort ne ""} {
                    set direction [expr {[lindex $sort 1] eq "asc" ? "increasing" : "decreasing"}]
                    ::template::multirow sort tbl_missing -${direction} [lindex $sort 0]
                }
                if {[::template::multirow size tbl_missing] ne 0} {
                    #parse html and insert date_widget into form
                    dom parse -html [template::list::render -name tbl_missing] doc
                    $doc documentElement root
                    set form [lindex [$root selectNodes "//div\[@class='list-button-bar-bottom'\]"] 0]
                    dom parse -html [:date_widget 1] dw
                    $dw documentElement dwroot
                    if {$form ne ""} {
                        $form insertBefore $dwroot [$form firstChild]
                    }
                    set root_html [$root asXML]
                    $doc delete
                    $dw delete
                } else {
                    set root_html [template::list::render -name tbl_missing]
                }
                append root_html "<br><a href=[$package_id pretty_link -parent_id [$package_id folder_id] index]>[_ tlf-assignments.back]</a>"
                return "$html $root_html"
            }
            ################### PARAMETER 2: LIST OF SUBMITTED, GRADED, OPEN ####################
            #get filter clauses
            set type [::xo::cc query_parameter type "allsubmissions"]
            set ast [::xo::db::CrClass get_instance_from_db -item_id [::xo::cc query_parameter view]]
            array set subm [$ast calc_submissions $type]
            append html [$ast render_angabe_full -prefetch "[array get subm]"]

            ### Liste Aufgaben in Bearbeitung ###
            if {$type eq "open"} {
                set bulk_actions [list [_ tlf-assignments.resub_deadline] [$ast pretty_link] [_ tlf-assignments.resub_deadline] ]
                set m write_nf
                set op set_resub

                ::template::multirow create tbl_open bearb_status matnr name user_id abgabe fristen nf nba item_id pretty_link
                ::template::list::create \
                -name "tbl_open" \
                -multirow "tbl_open" \
                -pass_properties {view type} \
                -has_checkboxes \
                -caption "#tlf-assignments.open#" \
                -no_data "#tlf-assignments.no_data#" \
                -bulk_actions $bulk_actions \
    -bulk_action_export_vars {m op return_url} \
                -key id \
    -elements [subst {
                    item_id {
                        label {<input id="tbl_open.check_all" name="_dummy" title="[_ acs-templating.lt_Checkuncheck_all_rows]" type="checkbox">}
                        html "align=center"
                        sub_class "narrow"
                        display_template {
                            <input type="checkbox" name="item_id" value="@tbl_open.item_id@" id="tbl_open.@tbl_open.item_id@" title="[_ acs-templating.lt_Checkuncheck_this_row]">
                        }
                    }
                    bearb_status {
                        label "#tlf-assignments.b_state#"
                    }
                    matnr {
                        label "#tlf-assignments.matnr#"
                    }
                    name {
                        label "Name"
                        display_template {
          <if @tbl_open.matnr@ eq "#tlf-assignments.gr_subm#">
                                <a href='groupmgr?id=@tbl_open.user_id@&a=view_detail&return_url=${return_url_encoded}'>@tbl_open.name@</a>
                            </if>
                            <elseif @tbl_open.matnr@ eq "undefined">
                                @tbl_open.name@
                            </elseif>
                            <else>
                                <a href='/shared/community-member?user_id=@tbl_open.user_id@&return_url=${return_url_encoded}'>@tbl_open.name@</a>
                                <a href=".?user_details=@tbl_open.user_id@&return_url=${return_url_encoded}" title="#tlf-assignments.results# @tbl_open.name@">
                                   <img src='/resources/tlf-assignments/images/icons_famfamfam/zoom_in.png'>
                                </a>
                            </else>
                        }
                    }
                    abgabe {
                        label "#tlf-assignments.subm#"
                            display_template {
                                @tbl_open.abgabe;noquote@
                            }
                    }
                    fristen {
                     label "#tlf-assignments.dline#"
                        display_template {
                            <if @tbl_open.nf@ ne "">
                               <div style='clear:both;'><span class='bold'>[_ tlf-assignments.nachfrist]:</span><br>@tbl_open.nf@</div>
                            </if>
                            <if @tbl_open.nba@ ne "">
                                <div style='clear:both;'><span class='bold'>[_ tlf-assignments.resub_deadline]:</span><br>@tbl_open.nba@</div>
                            </if>
                        }
                    }
                    actions {
                        label "#tlf-assignments.actions#"
                        display_template {
                            <a class='page-white-get' title='#tlf-assignments.submit_for#' href='@tbl_open.pretty_link@?m=foreign_submit&user_id=@tbl_open.user_id@'>&nbsp;</a>
                        }
                    }
                }] -orderby {
                    matnr {
                        orderby matnr
                    }
                    name {
                        orderby name
                    }
                    fristen {
                        orderby name
                    }
                }

    template::add_event_listener -id "tbl_open.check_all" \
        -script {acs_ListCheckAll('tbl_open', this.checked);}

                foreach submission $subm(returnvalue) {
                    ::xo::db::CrClass get_instance_from_db -item_id $submission
                    if {[$view get_property -name groups] ne ""} {
                        set user_id [$submission get_property -name creator_id]
                        if {$user_id eq ""} {
                            set user_id [$submission set creation_user]
                        }
                        if {[permission::permission_p -object_id $package_id -privilege "admin" -party_id $user_id]} {
                            set gr_id 0
                        } else {
                            set group_id [$view checkgroup $user_id]
                            set gr_id [lindex $group_id 1]
                        }
                        if {$gr_id eq 0} {set gr_id [$submission get_property -name group_id]}
                        set grname [::xo::dc get_value groupname "select group_name from groups where group_id = :gr_id" ""]
                        set user "[_ tlf-assignments.gr_subm]"
                        set matnr $user
                        set name $grname
                        set user_id $gr_id
                    } else {
                        set user_id [expr {[$submission get_property -name foreign_user] eq "0" ?
                            [$submission get_property -name creator_id] :
                            [$submission get_property -name foreign_user]}]
                        if {$user_id eq ""} {
                            set user_id [$submission set creation_user]
                        }
                        set matnr [::xo::dc get_value username "select username from acs_users_all where user_id = :user_id"  0]
                        set name [::tlf_cassignments::get_user_name -user_id $user_id]
                    }
                    set nf [$view germanize_date ${user_id}_nachfrist]
                    SubmissionType=[$view get_property -name exercise_form] create [self]::stype
                    set abgabe [[self]::stype render_preview -view_only 1 $submission ]
                    set resub [$submission germanize_date resubmissionff]
                    if {$resub ne ""} {
                        set bearb_status "#tlf-assignments.resub_open#"
                    } else {
                        set bearb_status "#tlf-assignments.open#"
                        set abgabe " -- "
                    }
                    #fristen is a compound of nf and nba
                    set fristen "$nf $resub"
                    ::template::multirow append tbl_open $bearb_status $matnr $name $user_id $abgabe $fristen $nf $resub [$submission set item_id] [$submission pretty_link]
                }
                    set sort [split $orderby ,]
                    if {$sort ne ""} {
                        set direction [expr {[lindex $sort 1] eq "asc" ? "increasing" : "decreasing"}]
                        ::template::multirow sort tbl_open -${direction} [lindex $sort 0]
                    }
                # append html [template::list::render -name tbl_open]
                if {[::template::multirow size tbl_open] ne 0} {
                    #parse html and insert date_widget into form
                    dom parse -html [template::list::render -name tbl_open] doc
                    $doc documentElement root
                    set form [lindex [$root selectNodes "//div\[@class='list-button-bar-bottom'\]"] 0]

                    dom parse -html [:date_widget 1] dw

                    $dw documentElement dwroot
                    if {$form ne ""} {
                        $form insertBefore $dwroot [$form firstChild]
                    }
                    set root_html [$root asXML]
                    $doc delete
                    $dw delete
                } else {
                    set root_html [template::list::render -name tbl_open]
                }
                return "$html $root_html"

            ### Liste Aufgaben Abgegeben ###
            } elseif {$type eq "submitted"} {
                set m bulk_download
                set bulk_actions ""
                if {[SubmissionType=[$view get_property -name exercise_form] set allow_download]} {
                    set bulk_actions [list "[_ tlf-assignments.dl]" "[$ast pretty_link]" "[_ tlf-assignments.dl_selected]"]
                }
                ::template::multirow create tbl_submitted matnr name abgabe beurteilung actions user_id item_id nachfrist nba
                ::template::list::create \
                -name "tbl_submitted" \
                -multirow "tbl_submitted" \
                -pass_properties {view type} \
                -has_checkboxes \
                -caption "#tlf-assignments.submitted_subs#" \
                -no_data "#tlf-assignments.no_data#" \
                -bulk_actions $bulk_actions \
                -bulk_action_export_vars {m return_url} \
                -key item_id \
                -elements [subst {
                    item_id {
                        label {<input id="tbl_submitted.check_all" name="_dummy" title="[_ acs-templating.lt_Checkuncheck_all_rows]" type="checkbox">}
                        html "align=center"
                        sub_class "narrow"
                        display_template {
                            <input type="checkbox" name="item_id" value="@tbl_submitted.item_id@" id="tbl_submitted.@tbl_submitted.item_id@" title="[_ acs-templating.lt_Checkuncheck_this_row]">
                        }
                    }
                    matnr {
                        label "#tlf-assignments.matnr#"
                    }
                    name {
                        label "Name"
                        display_template {
                            <if @tbl_submitted.matnr@ eq "#tlf-assignments.gr_subm#">
             <a href='groupmgr?id=@tbl_submitted.user_id@&a=view_detail&return_url=${return_url_encoded}'>@tbl_submitted.name@</a>
                            </if>
                            <elseif @tbl_submitted.matnr@ eq "undefined">
                               @tbl_submitted.name@
                            </elseif>
                            <else>
                               <a href='/shared/community-member?user_id=@tbl_submitted.user_id@&return_url=${return_url_encoded}'>@tbl_submitted.name@</a>
                               <a href=".?user_details=@tbl_submitted.user_id@&return_url=${return_url_encoded}" title="#tlf-assignments.results# @tbl_submitted.name@">
                                  <img src='/resources/tlf-assignments/images/icons_famfamfam/zoom_in.png'>
                               </a>
                            </else>
                        }
                    }
                    nachfrist {
                        label "#tlf-assignments.dline#"
                        display_template {
                            <if @tbl_submitted.nachfrist@ ne "">
                               <div style='clear:both;'><span class='bold'>[_ tlf-assignments.nachfrist]:</span><br>@tbl_submitted.nachfrist@</div>
                            </if>
                            <if @tbl_submitted.nba@ ne "">
                                <div style='clear:both;'><span class='bold'>[_ tlf-assignments.resub_deadline]:</span><br>@tbl_submitted.nba@</div>
                            </if>
                        }
                    }
                    abgabe {
                        label "#tlf-assignments.subm#"
                        display_template {
                            @tbl_submitted.abgabe;noquote@
                        }
                    }
                    beurteilung {
                        label "#tlf-assignments.quick_grade#"
                        display_template {
                            @tbl_submitted.beurteilung;noquote@
                        }
                    }
                    actions {
                        label "#tlf-assignments.actions#"
                        display_template {
                            <a class='bin-empty tlf-assignments.del_conf' href='@tbl_submitted.actions@' title='#xowiki.delete#'></a>
                        }
                    }
                }] -orderby {
                    matnr {
                        orderby matnr
                    }
                    name {
                        orderby name
                    }
                }

                template::add_event_listener -id "tbl_submitted.check_all" \
                    -script {acs_ListCheckAll('tbl_submitted', this.checked);}

                template::add_confirm_handler -CSSclass "tlf-assignments.del_conf" \
                    -message [_ tlf-assignments.del_conf]

                # Prevent hitting enter on the grading formfields to
                # trigger a form submit, which would try to execute
                # the form action on the including page, rather than
                # the submissions.
                template::add_body_handler -event load -script {
                    for (form of document.getElementsByName('tbl_submitted')) {
                        form.addEventListener('submit', function(e) {
                            e.preventDefault();
                        });
                    }
                }

                foreach submission $subm(returnvalue) {
                    ::xo::db::CrClass get_instance_from_db -item_id $submission
                    if {[$view get_property -name groups] ne ""} {
                        set user_id [$submission get_property -name creator_id]
                        if {[permission::permission_p -object_id $package_id -privilege "admin" -party_id $user_id]} {
                            set gr_id 0
                        } else {
                            set group_id [$view checkgroup $user_id]
                            set gr_id [lindex $group_id 1]
                        }
                        if {$gr_id eq 0} {set gr_id [$submission get_property -name group_id]}
                        set grname [::xo::dc get_value groupname "select group_name from groups where group_id = :gr_id" ""]
                        set user "#tlf-assignments.gr_subm#"
                        set matnr $user
                        set name $grname
                        set user_id $gr_id
                    } else {
                        set user_id [$submission get_property -name group_id]
                        if {$user_id eq ""} {
                            set user_id [$submission set creation_user]
                        }
                        set matnr [::xo::dc get_value username "select username from acs_users_all where user_id = :user_id"  0]
                        set name [::tlf_cassignments::get_user_name -user_id $user_id]
                    }
                    SubmissionType=[$view get_property -name exercise_form] create [self]::stype
                    set abgabe [[self]::stype render_preview $submission]
                    if {[$view get_property -name exercise_form] eq "ot"} {
                      set beurteilung "<div class='grey percent85'>#tlf-assignments.grade_nag#</div>"
                    } else {
                      GradingType=[$view get_property -name modus] create [self]::gtype
                      set beurteilung [[self]::gtype asHTMLInput $submission]
                    }
                    set actions "[$submission pretty_link]?m=delete&return_url=${return_url_encoded}"
                    set nf [$view germanize_date ${user_id}_nachfrist]
                    set resub [$submission get_property -name resubmissionff]
                    ::template::multirow append tbl_submitted $matnr $name $abgabe $beurteilung $actions $user_id [$submission set item_id] $nf $resub
                }
                set sort [split $orderby ,]
                if {$sort ne ""} {
                    set direction [expr {[lindex $sort 1] eq "asc" ? "increasing" : "decreasing"}]
                    ::template::multirow sort tbl_submitted -${direction} [lindex $sort 0]
                }
                append html [template::list::render -name tbl_submitted]

        ### Liste Aufgaben Beurteilt ###
            } elseif {$type eq "graded"} {
                set m bulk_download
                set bulk_actions ""
                if {[SubmissionType=[$view get_property -name exercise_form] set allow_download]} {
                    set bulk_actions [list "#tlf-assignments.dl#" "[$ast pretty_link]" "#tlf-assignments.dl_selected#"]
                }
                ::template::multirow create tbl_graded matnr name abgabe beurteilung actions user_id item_id grade_released
                ::template::list::create \
                -name "tbl_graded" \
                -multirow "tbl_graded" \
                -pass_properties {view type} \
                -has_checkboxes \
                -caption "#tlf-assignments.graded_subs#" \
                -bulk_actions $bulk_actions \
                -no_data "#tlf-assignments.no_data#" \
                -key item_id \
                -bulk_action_export_vars {m return_url} \
                -elements [subst {
                    item_id {
                        label {<input id="tbl_graded.check_all" name="_dummy" title="[_ acs-templating.lt_Checkuncheck_all_rows]" type="checkbox">}
                        html "align=center"
                        sub_class "narrow"
                        display_template {
                            <input type="checkbox" name="item_id" value="@tbl_graded.item_id@" id="tbl_graded.@tbl_graded.item_id@" title="[_ acs-templating.lt_Checkuncheck_this_row]">
                        }
                    }
                    matnr {
                        label "#tlf-assignments.matnr#"
                    }
                    name {
                        label "Name"
                        display_template {
                            <if @tbl_graded.matnr@ eq "#tlf-assignments.gr_subm#">
                                <a href='groupmgr?id=@tbl_graded.user_id@&a=view_detail&return_url=${return_url_encoded}'>@tbl_graded.name@</a>
                            </if>
                            <elseif @tbl_graded.matnr@ eq "undefined">
                                @tbl_graded.name@
                            </elseif>
                            <else>
                                <a href='/shared/community-member?user_id=@tbl_graded.user_id@&return_url=${return_url_encoded}'>@tbl_graded.name@</a>
                                <a href=".?user_details=@tbl_graded.user_id@&return_url=${return_url_encoded}" title="#tlf-assignments.results# @tbl_graded.name@">
                                   <img src='/resources/tlf-assignments/images/icons_famfamfam/zoom_in.png'>
                                </a>
                            </else>
                            <if @tbl_graded.grade_released@ eq "1">
                                <img src='/resources/tlf-assignments/images/icons_famfamfam/tick.png' title='#tlf-assignments.published#'>
                            </if>
                        }
                    }
                    abgabe {
                        label "#tlf-assignments.subm#"
                        display_template {
                            @tbl_graded.abgabe;noquote@
                        }
                    }
                    beurteilung {
                        label "#tlf-assignments.grading#"
                    }
                    actions {
                        label "#tlf-assignments.actions#"
                        display_template {
                            <a class='bin-empty tlf-assignments.del_conf' href='@tbl_graded.actions@' title='#xowiki.delete#'></a>
                        }
                    }
    }] -orderby {
                    matnr {
                        orderby matnr
                    }
                    beurteilung {
                        orderby beurteilung
                    }
                    name {
                        orderby name
                    }
                }

                template::add_event_listener -id "tbl_graded.check_all" \
                    -script {acs_ListCheckAll('tbl_graded', this.checked);}

                template::add_confirm_handler -CSSclass "tlf-assignments.del_conf" \
                    -message [_ tlf-assignments.del_conf]

                foreach submission $subm(returnvalue) {
                    ::xo::db::CrClass get_instance_from_db -item_id $submission
                    if {[$view get_property -name groups] ne ""} {
                        set user_id [$submission get_property -name creator_id]
                        if {[permission::permission_p -object_id $package_id -privilege "admin" -party_id $user_id]} {
                            set gr_id 0
                        } else {
                            set group_id [$view checkgroup $user_id]
                            set gr_id [lindex $group_id 1]
                        }
                        if {$gr_id eq 0} {set gr_id [$submission get_property -name group_id]}
                        set grname [::xo::dc get_value groupname "select group_name from groups where group_id = :gr_id" ""]
                        set user "#tlf-assignments.gr_subm#"
                        set matnr $user
                        set name $grname
                        set user_id $gr_id
                    } else {
                        set user_id [$submission get_property -name group_id]
                        if {$user_id eq ""} {
                            set user_id [$submission set creation_user]
                        }
                        set matnr [::xo::dc get_value username "select username from acs_users_all where user_id = :user_id"  0]
                        set name [::tlf_cassignments::get_user_name -user_id $user_id]
                    }
                    SubmissionType=[$view get_property -name exercise_form] create [self]::stype
                    set abgabe [[self]::stype render_preview $submission]
                    GradingType=[$view get_property -name modus] create [self]::gtype
                    set beurteilung [[self]::gtype asHTMLInput $submission]
                    set actions "[$submission pretty_link]?m=delete&return_url=${return_url_encoded}"
                    ::template::multirow append tbl_graded $matnr $name $abgabe $beurteilung $actions $user_id [$submission set item_id] [$view get_property -name grade_released]
                }
                set sort [split $orderby ,]
                if {$sort ne ""} {
                    set direction [expr {[lindex $sort 1] eq "asc" ? "increasing" : "decreasing"}]
                    ::template::multirow sort tbl_graded -${direction} [lindex $sort 0]
                }
                append html [template::list::render -name tbl_graded]
                #individual grade release
                if {[$view get_property -name beurteilung] eq "individual" && [$view get_property -name grade_released] eq ""} {
                    append html "<br><a class='button' href='[$view pretty_link]?m=release_grade&return_url=${return_url_encoded}'>#tlf-assignments.release_grades#</a>
<img width='12' height='9' border='0' style='margin-right: 5px' title='Help text' alt='\[i\]' src='/shared/images/info.gif'>#tlf-assignments.info_publish#"
                }
            }

            ############ END List TEMPLATES ###################
            if {$type eq "submitted" && $subm(returnvalue) ne "" && \
                [SubmissionType=[$view get_property -name exercise_form] set allowQuickGrade] && \
                [GradingType=[$view get_property -name modus] allowQuickGrade]} {
                set name [$ast set name]
                set id "grade-all-button-${name}"
                append html "<a id='${id}' class='button' href='#'>#tlf-assignments.grade_selected#</a>"
                template::add_event_listener -id $id -script [subst {grade_all('${name}');}]
            }
            return $html
        }

        if {[set user_details [::xo::cc query_parameter user_details]] ne "" && $amiadmin} {
            ::template::multirow create tbl_userdetails matnr name abgabe beurteilung comment pretty_link user_id item_id status typ title
            set type [acs_object_type $user_details]
            set matnr [expr {$type eq "user" ? \
                [::xo::dc get_value username "select username from acs_users_all where user_id = :user_details"  0] :
                [::xo::dc get_value groupname "select group_name from groups where group_id = :user_details" 0]}]
            ::template::list::create \
                -name "tbl_userdetails" \
                -multirow "tbl_userdetails" \
                -pass_properties {view type} \
                -caption "[expr {$type eq "user" ? [::tlf_cassignments::get_user_name -user_id $user_details] : "#tlf-assignments.gr_subm#"}]  ($matnr)" \
                -no_data "#tlf-assignments.no_data#" \
                -key item_id \
                -bulk_action_export_vars {m return_url} \
                -elements {
                    title {
                        label "#tlf-assignments.title#"
                    }
                    abgabe {
                        label "#tlf-assignments.subm#"
                        display_template {
                            @tbl_userdetails.abgabe;noquote@
                        }
                    }
                    beurteilung {
                        label "#tlf-assignments.grading#"
                    }
                    comment {
                        label "#tlf-assignments.supercomment#"
                    }
                    typ {
                        label "#tlf-assignments.grade_mode#"
                    }
                    status {
                        label "Status"
                        display_template {
                            <if @tbl_userdetails.status@ eq "graded">#tlf-assignments.graded#</if>
                            <if @tbl_userdetails.status@ eq "submitted">#tlf-assignments.submitted#</if>
                            <if @tbl_userdetails.status@ eq "resubmission">#tlf-assignments.resub#</if>
                            <if @tbl_userdetails.status@ eq "initial">#tlf-assignments.open#</if>
                        }
                    }
                    pretty_link {
                        label "#tlf-assignments.actions#"
                        display_template {
                            <if @tbl_userdetails.status@ eq "resubmission">
                            <a href='@tbl_userdetails.pretty_link@'>Details</a>
                            </if>
                            <elseif @tbl_userdetails.status@ ne "initial">
                                <a href='@tbl_userdetails.pretty_link@'>Details</a>
                            </elseif>
                        }
                    }
                }
            set creator_clause [expr {$type eq "user" ? "(((hkey->'creator_id')::integer) = $user_details or \
            ((hkey->'foreign_user')::integer) = $user_details or \
            acs_group__member_p($user_details, (hkey->'group_id')::integer, 1::boolean))" :
            "(hkey->'group_id')::integer = $user_details"}]

            set users_assignments [::xowiki::FormPage get_form_entries -base_item_ids [string trimleft [$package_id resolve_page abgabe-stud.wf method_var] :] \
            -form_fields [list] -always_queried_attributes "_state _description _instance_attributes _creation_date" -package_id $package_id \
            -orderby "state desc, (hkey->'time_to') asc, title asc" -publish_status "ready" \
            -parent_id [$package_id set folder_id] -extra_where_clause " and $creator_clause" -from_package_ids "*"]
            foreach ast [$users_assignments children] {
                   catch {::xo::db::CrClass get_instance_from_db -item_id [$ast get_property -name assignment_id]} err
                   if {[info command ::[$ast get_property -name assignment_id]] eq ""} {continue}
                    GradingType=[[$ast get_property -name assignment_id] get_property -name modus] create [self]::gtype
                   ::template::multirow append tbl_userdetails \
                   $matnr \
                   [expr {$type eq "user" ? [::tlf_cassignments::get_user_name -user_id $user_details] : "#tlf-assignments.gr_subm#"}]\
                   [expr {[$ast get_property -name submission_date] ne "" ? [clock format [$ast get_property -name submission_date] -format  {%d.%m.%Y %H:%M}] : ""}] \
                   [$ast get_property -name grade] \
                   [$ast get_property -name supervisorcomment] \
                   [$ast pretty_link] \
                   $user_details \
                   [$ast item_id] \
                   [expr {[$ast get_property -name resubmissionff] ne "" ? "resubmission" : [$ast set state]}] \
                   [[self]::gtype PrettyName] \
                   [[$ast get_property -name assignment_id] set title]
            }
            return "[template::list::render -name tbl_userdetails] <br> <a class='button' href='[::xo::cc query_parameter return_url]'>#tlf-assignments.back#</a>"
        }



        ################# START PAGE ##########################
        if {$amiadmin} {
#            ::xo::Page set_property doc menubar [$package_id MenuBar]
            if {[$assignments children] eq ""} {
                append html "<div class='welcome-text'>#tlf-assignments.Welcome_text#</div>"
                return $html
            }
            set bulk_actions [list \
            "[_ xowiki.delete]" admin/bulk-delete "[_ xowiki.Delete_selected]"]
            ::template::multirow create all_exercises type title link is_enabled status open_date end_date s_missing s_submitted s_graded s_open item_id pretty_timeto exercise_form
            ::template::list::create \
            -name "all_exercises" \
            -multirow "all_exercises" \
            -key item_id \
            -bulk_actions $bulk_actions \
            -elements [subst {
                type {
                    label ""
                    display_template {
                        <if @all_exercises.type@ ne 1>
                            <img src='/resources/tlf-assignments/images/icons/16_gruppenaufgabe.png' title='#tlf-assignments.group_ex#'>
                        </if>
                        <else>
                            <img src='/resources/tlf-assignments/images/icons/16_einzelaufgabe.png' title='#tlf-assignments.single_ex#'>
                        </else>
                    }
                }
                title {
                    label "#tlf-assignments.title#"
                    display_template {
                        <a href='@all_exercises.link@'>@all_exercises.title@</a>
                        <br><span class='grey percent85'>@all_exercises.exercise_form@</span>
                    }
                }
                is_enabled {
                    label "#tlf-assignments.state#"
                    display_template {
                        <if @all_exercises.is_enabled;literal@ true>
                            <span class='notice n8 grey percent85' title='#tlf-assignments.is_running_help#'>#tlf-assignments.is_running#</span>
                        </if>
                        <else>
                           <if @all_exercises.status@ eq "initial">
                                <span class='notice n5 grey percent85' title='#tlf-assignments.draft_help#'>#tlf-assignments.draft#</span>
                           </if>
                           <elseif @all_exercises.status@ eq "editing">
                                <span class='notice n5 grey percent85' title='#tlf-assignments.draft_help#'>#tlf-assignments.draft#</span>
                           </elseif>
                           <elseif @all_exercises.status@ eq "assign">
                                <span class='notice n5 grey percent85' title='#tlf-assignments.draft_help2#'>#tlf-assignments.draft#</span>
                           </elseif>
                           <elseif @all_exercises.status@ eq "published">
                                <if [clock seconds] gt @all_exercises.pretty_timeto@>
                                    <span class='notice n9 grey percent85' title='#tlf-assignments.time_up_help#'>#tlf-assignments.time_up#</span>
                                </if>
                                <else>
                                    <span class='notice n7 grey percent85' title='#tlf-assignments.ready_help#'>#tlf-assignments.ready#</span>
                                </else>
                           </elseif>
                        </else>
                     }
                }
                open_date {
                    label "#tlf-assignments.sub_time#"
                    display_template {
                        <div style='white-space:nowrap;'>
                            <span style='width:4em;display:inline-block;'>#tlf-assignments.start#:</span>
                            @all_exercises.open_date@
                        </div>
                            <div style='white-space:nowrap;'>
                            <span style='width:4em;display:inline-block;'>#tlf-assignments.end#:</span>
                            @all_exercises.end_date@
                        </div>
                    }
                }
                submissions {
                    label "#tlf-assignments.sub_pl#"
                    display_template {
                        <if $amiadmin eq t>
                            <ul class='horizontal-list' style='margin-left:0 !important;'>
                                <li style='width:3.8em;'><a class='abgaben n10' href='?view=@all_exercises.item_id@&type=missing' title='#tlf-assignments.missing#'>@all_exercises.s_missing@</a></li>
                                <li style='width:3.8em;'><a class='abgaben n11' href='[::xo::cc url]?view=@all_exercises.item_id@&type=open' title='#tlf-assignments.open#'>@all_exercises.s_open@</a></li>
                                <li style='width:3.8em;'><a class='abgaben n12' href='[::xo::cc url]?view=@all_exercises.item_id@&type=submitted' title='#tlf-assignments.submitted#'>@all_exercises.s_submitted@</a></li>
                                <li style='width:3.8em;'><a class='abgaben n13' href='[::xo::cc url]?view=@all_exercises.item_id@&type=graded' title='#tlf-assignments.graded#'>@all_exercises.s_graded@</a></li>
                            </ul>
                        </if>
                    }
                }
                actions {
                    label "#tlf-assignments.actions#"
                    sub_class narrow
                    display_template {
                        <a href='@all_exercises.link@?m=edit' class='page-white-edit' title='bearbeiten'>&nbsp;</a>
                        <a href='@all_exercises.link@?m=delete' class='bin-empty tlf-assignments.del_conf' title='#xowiki.delete#'>&nbsp;</a>
                        <if @all_exercises.s_graded@ gt 0>
                            <a href='@all_exercises.link@?m=csv_export' class='report' title='#tlf-assignments.csv_export#'>&nbsp;</a>
                            <a href='@all_exercises.link@?m=csv_export&all=1' class='report_user' title='#tlf-assignments.csv_export_all#'>&nbsp;</a>
                        </if>
                        <if @all_exercises.exercise_form@ eq "Peer review">
                            <a href='@all_exercises.link@?m=csv_export_ot' class='page_white_excel' title='#tlf-assignments.csv_export#'>&nbsp;</a>
                        </if>
                    }
                }
            }]

            template::add_confirm_handler -CSSclass "tlf-assignments.del_conf" \
                -message [_ tlf-assignments.del_conf]

            set comm_clause [expr {$display_members ? "-community_id $community_id" : ""}]
            set cmd "::tlf_cassignments::get_all_counts -package_id $package_id -display_members $display_members $comm_clause"
            array set subs [{*}$cmd]
            if {$display_members} {
                set members [::xo::dc get_value get_members {SELECT count(*) as count FROM dotlrn_member_rels_approved
                                    WHERE dotlrn_member_rels_approved.community_id = :community_id
                                                AND dotlrn_member_rels_approved.rel_type IN
                                                ('dotlrn_student_rel','dotlrn_member_rel')}]
            } else {
                set members [::xo::dc get_value get_members {SELECT count(*) as count FROM dotlrn_member_rels_approved
                                    WHERE dotlrn_member_rels_approved.community_id
                                        IN (SELECT community_id FROM dotlrn_community_applets
                                            WHERE package_id=:package_id)
                                                AND dotlrn_member_rels_approved.rel_type IN
                                                ('dotlrn_student_rel','dotlrn_member_rel')}]
            }
            foreach fp [$assignments children] {
                set is_enabled [expr {[$fp check_submittable 0] eq "" ? 0 : 1}]
                if {[$fp set state] ne "published"} {
                    set is_enabled 0
                }
                set e_form [SubmissionType=[$fp get_property -name exercise_form] asOption]
                set state [$fp set state]
                set submitted [expr {[set sub [lindex [array get subs [$fp set item_id]_submitted]  1]] ne "" ? $sub : 0}]
                set graded [expr {[set sub [lindex [array get subs [$fp set item_id]_graded]  1]] ne "" ? $sub : 0}]
                set open [expr {[set sub [lindex [array get subs [$fp set item_id]_open]  1]] ne "" ? $sub : 0}]
                set bearb [$fp get_property -name bearbeiter]
                set gr [$fp get_property -name groups]
                if {$gr ne ""} {
                    set missing [expr {[llength $gr] - $submitted - $graded - $open}]
                } elseif {$bearb ne ""} {
                    set missing [expr {[llength $bearb] - $submitted - $graded - $open}]
                } else {
                    set missing  [expr {$members - $graded - $open - $submitted}]
                }
                if {$missing < 0} {
                    set missing 0
                    ns_log notice "tlf-ast debug missing was < 0"
                }
                ::template::multirow append all_exercises \
                    [expr {[$fp get_property -name groups] eq ""}] \
                    [$fp set title] \
                    [$fp pretty_link] \
                    $is_enabled \
                    $state \
                    [$fp germanize_date time_from] \
                    [$fp germanize_date time_to] \
                    $missing \
                    $submitted \
                    $graded \
                    $open \
                    [$fp set item_id] \
                    [clock scan [$fp get_property -name time_to]] \
                    [lindex $e_form 0]
                #array unset subs
            }
            array unset subs
            append html [template::list::render -name all_exercises]

            #display shared applets
            if {$is_shared} {
                append html "<p>[_ tlf-assignments.shared_package]</p>"
                ::xo::dc foreach shared_pk "select
                dci.shortname,
                dcc.pretty_name,
                dcc.community_id as cid
                from dotlrn_class_instances dci
                    inner join dotlrn_community_applets dcsa on
                        dci.class_instance_id = dcsa.community_id
                        and dcsa.package_id = :package_id
                        and dci.class_instance_id <> :community_id
                            inner join dotlrn_communities_core dcc
                            on dci.class_instance_id = dcc.community_id " {
                    append html "<a href='[dotlrn_community::get_community_url $cid][ast_installer node_name]'>$shortname $pretty_name</a><br>"
                }
            }
            return $html
            #### STUDENT ####
        } else {
            if {[$assignments children] eq ""} {
                append html "<h3>#tlf-assignments.start_empty#</h3>"
                return $html
            }
            set bulk_actions ""
            ::template::multirow create all_exercises type title link is_enabled status sort_order_status open_date end_date nf exercise_mode abg_status sort_order_abgabe grade check_vis abgabe_link resubmission points hidden pretty_timefrom pretty_timeto exercise_form
            ::template::list::create \
                -name "all_exercises" \
                -multirow "all_exercises" \
                -key item_id \
                -bulk_actions $bulk_actions \
                -elements [subst {
                    type {
                        label ""
                        display_template {
                            <if @all_exercises.type@ ne 1>
                                <img src='/resources/tlf-assignments/images/icons/16_gruppenaufgabe.png' title='#tlf-assignments.group_ex#'>
                            </if>
                            <else>
                                <img src='/resources/tlf-assignments/images/icons/16_einzelaufgabe.png' title='#tlf-assignments.single_ex#'>
                            </else>
                        }
                    }
                    title {
                        label "#tlf-assignments.title#"
                        display_template {
                            <if @all_exercises.hidden@ eq 1>
                                <if [clock seconds] gt @all_exercises.pretty_timefrom@>
                                    <a href='@all_exercises.link@'>@all_exercises.title@</a>
                                    <br><span class='grey percent85'>@all_exercises.exercise_form@</span>
                                </if>
                                <else>
                                    @all_exercises.title@
                                    <br><span class='grey percent85'>@all_exercises.exercise_form@</span>
                                </else>
                            </if>
                            <else>
                                <if @all_exercises.abg_status@ eq "">
                                    <a href='@all_exercises.link@'>@all_exercises.title@</a>
                                    <br><span class='grey percent85'>@all_exercises.exercise_form@</span>
                                </if>
                                <else>
                                    <if @all_exercises.check_vis@ eq "1">
                                        <a href='@all_exercises.abgabe_link@'>@all_exercises.title@</a>
                                    </if>
                                    <else>
                                        @all_exercises.title@
                                    </else>
                                    <br><span class='grey percent85'>@all_exercises.exercise_form@</span>
                                </else>
                            </else>
                        }
                    }
                    is_enabled {
                        label "#tlf-assignments.state#"
                        display_template {
                            <if @all_exercises.is_enabled;literal@ true>
                                <span class='notice-3fields n29 grey percent85' title='#tlf-assignments.is_running_help#'>#tlf-assignments.is_running#</span>
                            </if>
                            <else>
                                <if @all_exercises.status@ eq "published">
                                    <if [clock seconds] gt @all_exercises.pretty_timeto@>
                                        <span class='notice-3fields n27 grey percent85' title='#tlf-assignments.time_up_help#'>#tlf-assignments.closed#</span>
                                    </if>
                                    <else>
                                        <span class='notice-3fields n28 grey percent85' title='#tlf-assignments.ready_help#'>#tlf-assignments.ready#</span>
                                    </else>
                                </if>
                                <else>
                                    <span class='notice-3fields n27 grey percent85' title='#tlf-assignments.time_up_help#'>#tlf-assignments.closed#</span>
                                </else>
                            </else>
                         }
                    }
                    open_date {
                        label "#tlf-assignments.sub_time#"
                        display_template {
                            <div style='white-space:nowrap;'>
                                <span style='width:4em;display:inline-block;'>#tlf-assignments.start#:</span>
                                @all_exercises.open_date@
                            </div>
                            <div style='white-space:nowrap;'>
                                <span style='width:4em;display:inline-block;'>#tlf-assignments.end#:</span>
                                @all_exercises.end_date@
                            </div>
                            <if @all_exercises.nf@ ne "">
                                    <div class='bold'>#tlf-assignments.nachfrist#:</div>
                                    <div style='white-space:nowrap;'>
                                        <span style='width:4em;display:inline-block;'>#tlf-assignments.end#:</span>
                                        @all_exercises.nf@
                                    </div>
                            </if>
                            <if @all_exercises.resubmission@ ne "">
                                    <div class='bold'>#tlf-assignments.resub_deadline#:</div>
                                    <div style='white-space:nowrap;'>
                                        <span style='width:4em;display:inline-block;'>#tlf-assignments.end#:</span>
                                        @all_exercises.resubmission@
                                    </div>
                            </if>
                        }
                    }
                    submissions {
                        label "#tlf-assignments.b_state#"
                        display_template {
                        <if @all_exercises.abg_status@ eq "initial">
                            <if @all_exercises.resubmission@ ne "">
                                <div class='abgaben n11'>
                                    [_ tlf-assignments.resub_open] (<a href='@all_exercises.abgabe_link@'>#xowiki.edit#</a>)
                                </div>
                            </if>
                            <else>
                                <div class='abgaben n11'>
                                    [_ tlf-assignments.is_open] (<a href='@all_exercises.abgabe_link@'>#xowiki.edit#</a>)
                                </div>
                            </else>
                        </if>
                        <elseif @all_exercises.abg_status@ eq "rate">
                            <div class='abgaben n11'>
                                 [_ tlf-assignments.is_open] (<a href='@all_exercises.abgabe_link@'>#xowiki.edit#</a>)
                            </div>
                        </elseif>
                         <elseif @all_exercises.abg_status@ eq "submitted">
                            <div class='abgaben n12'>
                                 [_ tlf-assignments.is_submitted] (<a href='@all_exercises.abgabe_link@'>#tlf-assignments.details#</a>)
                            </div>
                        </elseif>
                        <elseif @all_exercises.abg_status@ eq "grade_state">
                            <div class='abgaben n12'>
                             [_ tlf-assignments.is_submitted] (<a href='@all_exercises.abgabe_link@'>#tlf-assignments.details#</a>)
                            </div>
                        </elseif>
                         <elseif @all_exercises.abg_status@ eq "resubmission">
                            <div class='abgaben n12'>
                             [_ tlf-assignments.is_submitted] (<a href='@all_exercises.abgabe_link@'>#tlf-assignments.details#</a>)
                            </div>
                        </elseif>
                         <elseif @all_exercises.abg_status@ eq "graded">
                            <if @all_exercises.check_vis@ eq 1>
                            <if @all_exercises.grade@ ne "">
                                <div class='abgaben n13'>
                                    [_ tlf-assignments.is_graded] (<a href='@all_exercises.abgabe_link@'>#tlf-assignments.details#</a>)
                                </div>
                            </if>
                            <elseif @all_exercises.exercise_mode@ eq "#tlf-assignments.type_comment#">
                                <div class='abgaben n13'>
                                    [_ tlf-assignments.is_graded] (<a href='@all_exercises.abgabe_link@'>#tlf-assignments.details#</a>)
                                </div>
                            </elseif>
                            </if>
                            <else>
                                <div class='abgaben n13'>
                                    [_ tlf-assignments.is_graded]
                                </div>
                            </else>
                        </elseif>
                        <else>
                            <div class='abgaben n10'>
                                   [_ tlf-assignments.missing]
                            </div>
                        </else>
                        }
                    }
                    actions {
                        label "#tlf-assignments.grading#"
                        sub_class narrow
                        display_template {
                            <if @all_exercises.check_vis@ eq "1">
                            <if @all_exercises.abg_status@ eq "graded">
                                @all_exercises.grade@
                                 <if @all_exercises.exercise_mode@ eq "#tlf-assignments.points#">
                                    von @all_exercises.points@
                                </if>
                                (@all_exercises.exercise_mode@)
                            </if>
                            </if>
                            <elseif @all_exercises.resubmission@ ne "">
                                [_ tlf-assignments.resub_help]
                            </elseif>
                        }
                    }
                }]
            foreach fp [$assignments children] {
                if {[lindex [$fp checkgroup [::xo::cc user_id]] 1] eq 0} {
                    continue
                }
                set is_enabled [expr {[$fp check_submittable 0] eq "" ? 0 : 1}]
                if {[$fp set state] ne "published"} {
                    set is_enabled 0
                }
                set nf [$fp get_property -name [lindex [$fp checkgroup [::xo::cc user_id]] 1]_nachfrist]
                set abgabe "abgabe_[$fp set item_id]__[lindex [$fp checkgroup [::xo::cc user_id]] 1]"
                set abgabe_exists [$package_id lookup -name $abgabe]
                GradingType=[$fp get_property -name modus] create [self]::gtype
                set exercise_mode [[self]::gtype PrettyName]
                set grade ""
                set abgabe_link ""
                set resubmission ""
                if {$abgabe_exists ne 0} {
                    set abgabe [::xo::db::CrClass get_instance_from_db -item_id $abgabe_exists]
                    set is_enabled [expr {[$abgabe_exists check_submittable 0] eq "" ? 0 : 1}]
                    set grade [$abgabe get_property -name grade]
                    set abgabe_link [$abgabe pretty_link]
                    set resubmission [$abgabe germanize_date resubmissionff]
                }
                set sort_order_status ""
                if {$is_enabled eq 1} {
                    set sort_order_status 0
                } else {
                    if {[clock seconds] > [clock scan [$fp get_property -name time_to]]} {
                        set sort_order_status 2
                    } else {
                        set sort_order_status 1
                    }
                }
                set e_form [SubmissionType=[$fp get_property -name exercise_form] asOption]
                set state [$fp set state]
                set abg_status ""
                if {$abgabe_exists ne 0} {
                     set abg_status [$abgabe_exists set state]
                } else {
                    set abg_status ""
                }
                set sort_order_abgabe ""
                if {$abg_status eq 0} {
                    set sort_order_abgabe 0
                } elseif {$abg_status eq "initial"} {
                    set sort_order_abgabe 10
                } elseif {$abg_status eq "rate"} {
                    set sort_order_abgabe 20
                } elseif {$abg_status eq "submitted"} {
                    set sort_order_abgabe 30
                } elseif {$abg_status eq "grade_state"} {
                    set sort_order_abgabe 40
                } elseif {$abg_status eq "resubmission"} {
                    set sort_order_abgabe 50
                } elseif {$abg_status eq "graded"} {
                    set sort_order_abgabe 60
                }
                ::template::multirow append all_exercises \
                    [expr {[$fp get_property -name groups] eq ""}] \
                    [$fp set title] \
                    [$fp pretty_link] \
                    $is_enabled \
                    $state \
                    $sort_order_status \
                    [$fp germanize_date time_from] \
                    [$fp germanize_date time_to] \
                    [lc_time_fmt $nf "%d.%m.%Y %H:%M"] \
                    $exercise_mode \
                    $abg_status \
                    $sort_order_abgabe \
                    $grade \
                    [expr {$abgabe_link eq "" ? 0 :[$fp check_grade_vis]}] \
                    $abgabe_link \
                    $resubmission \
                    [$fp get_property -name points] \
                    [$fp get_property -name verbergen] \
                    [clock scan [$fp get_property -name time_from]]\
                    [clock scan [$fp get_property -name time_to]] \
                    [lindex $e_form 0]
            }
            array unset subs
            ::template::multirow sort all_exercises sort_order_status sort_order_abgabe
            append html [template::list::render -name all_exercises]

            return $html
        }
    }

    tlf_assignment_list instproc date_widget {id} {
        set months  [lang::message::lookup [::xo::cc set locale] acs-lang.localization-mon]
        set days {1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31}
        set monthwidget "<select name='month' id='nf${id}.month'>
    [ad_generic_optionlist $months [list 1 2 3 4 5 6 7 8 9 10 11 12] [regsub {^0*(.+)} [clock format [clock seconds] -format %m] {\1}]]</select>"
        set daywidget "<select name='day' id='nf${id}.DD'>
    [ad_generic_optionlist $days $days [clock format [clock seconds] -format %d]]</select>"
        set hourwidget "<select name='hour' id='nf${id}.HH24'>
            [ad_integer_optionlist 1 24 [clock format [clock seconds] -format %H]]</select>"
        set minutewidget "<select name='minute' id='nf${id}.MI'>
        [ad_generic_optionlist [list 00 05 10 15 20 25 30 35 40 45 50 55] [list 0 5 10 15 20 25 30 35 40 45 50 55]  [clock format [clock seconds] -format %M]]</select>"
        set year "<input name='year' id='nf${id}.YYYY' size='4' value='[clock format [clock seconds] -format %Y]'>"
            return [subst "<div><fieldset style='margin: 0px; padding: 0px;' id='nf${id}'> $daywidget $monthwidget $year $hourwidget : $minutewidget </fieldset></div>"]
    }
}
