ad_library {
    provides support for lecturecasting portlets
    @author: mmoser
}

namespace eval tlf_assignment_portlet {

    ad_proc -private get_my_name {
    } {
        return "tlf_assignment_portlet"
    }

    ad_proc -private get_pretty_name {} {
        Get portlet pretty name
    } {
        return "#tlf-assignments.mod_title#"
    }

    ad_proc -private link {} {
        Get portlet link
    } {
        return ""
    }

    ad_proc -private add_self_to_page {
        {-portal_id:required}
        {-package_id:required}
        {-param_action:required}
    } {
        Adds a podcast portlet to the given portal
    } {
        #ns_log notice "fancy portlet: adding to portal $portal_id [get_my_name] $package_id $param_action"
        return [portal::add_element_parameters \
                    -portal_id $portal_id \
                    -portlet_name [get_my_name] \
                    -pretty_name [get_pretty_name] \
                    -value $package_id \
                    -sort_key 0 \
                    -param_action $param_action
               ]
    }

    ad_proc -private remove_self_from_page {
        {-portal_id:required}
        {-package_id:required}
    } {
        Removes a portlet from the given page or just the given package_id
    } {
        portal::remove_element_parameters \
            -portal_id $portal_id \
            -portlet_name [get_my_name] \
            -key package_id \
            -value $package_id
    }

    ad_proc -private show {
        cf
    } {
        Show portlet
    } {
        #ns_log notice "fancy portlet: something will be shown! $cf"
        portal::show_proc_helper \
            -template_src "tlf_assignment-portlet" \
            -package_key "tlf-assignments" \
            -config_list $cf
    }
}
