##::xo::db::require package xowf
::xo::library require -package xowf xowf-procs

Class create GenericSubmissionType \
	-parameter { {bewertungsmodus ""}}

GenericSubmissionType instproc special_submit_action {obj} {
    return ""
}

GenericSubmissionType instproc post_grading_action {obj} {
    return ""
}

GenericSubmissionType proc allow_draft {} {return 0}
GenericSubmissionType proc auto_handin {} {return 0}

######################################################
# SubmissionType=File
######################################################
Class create SubmissionType=file -superclass GenericSubmissionType -parameter {}
SubmissionType=file set allow_download 1
SubmissionType=file set rating_needed 0
SubmissionType=file set allow_resub 1
SubmissionType=file set allow_regrade 1
SubmissionType=file set allowQuickGrade 1
SubmissionType=file proc allow_draft {} {return 1}

SubmissionType=file proc asOption {} {
    return {{#tlf-assignments.fileex#} {file}}
}

SubmissionType=file proc elegible_types {} {
    return [list "alle" "einzelne" "gruppe"]
}

SubmissionType=file instproc form_info {obj ast} {
    set subm "
    @file1@
   [$obj multiple_files file]
   "
    # set form_info_final "
    # <div class=\"form-help-text\">
    # <img width=\"12\" height=\"9\" border=\"0\" style=\"margin-right: 5px\" title=\"Help text\" src=\"/shared/images/info.gif\">
    # [_ tlf-assignments.abgabe_help]</div>"
    set form_info_final "
    <div>
        <br><span class='information'>[_ tlf-assignments.abgabe_help]</span>&nbsp;<span class='bold'>[_ tlf-assignments.abgabe_help2]</span><br>
        <span class='information blank'>[_ tlf-assignments.abgabe_save_draft_instead]</span>
    </div>
    "
        set rev [$obj set revision_id]
        set id [$obj set item_id]
        set lastrev [::xo::dc get_value rev "select max(revision_id) from xowiki_form_pagei bt where item_id = :id and revision_id != :rev"]
        set resubon 0
        if {$lastrev ne ""} {
        ::xo::db::CrClass get_instance_from_db -revision_id $lastrev
        set resubon [expr {[$lastrev set state] eq "resubmission"}]
        }
    set fc "
     {file1:pretty_file,label=#tlf-assignments.my_sub#,size=10,resub=$resubon,required=1}
      file2:pretty_file,label=,size=10,resub=$resubon
                file3:pretty_file,label=,size=10,resub=$resubon
                file4:pretty_file,label=,size=10,resub=$resubon
                file5:pretty_file,label=,size=10,resub=$resubon
    "

    return [list subm $subm form_info_final $form_info_final fc $fc]
}

SubmissionType=file instproc submission_form_html {obj ast} {
    set ff ""

     for {set i 1} {$i < 6} {incr i} {
            if {[$obj get_property -name file$i] ne "" } {
                append ff @file$i@\n
            }
        }
    append html [$obj collect_submissions]
    #append html "<div class='submission-title'>Aktuelle Abgabe</div>"
    set stud [$obj get_property -name creator_id]
      if {[$ast get_property -name groups] ne ""} {
                    set group_id [$obj get_property -name group_id]
            if {[set sd [$obj get_property -name submission_date]] ne ""} {
                append html "<div class='submission-title'>[_ tlf-assignments.cur_sub] [clock format $sd -format {%d.%m.%Y %H:%M}]</div>"
            } else {
               append html "<div class='submission-title'>[_ tlf-assignments.cur_sub]</div>"
            }
            set gname [::xo::dc get_value group_name "select group_name from groups where group_id = :group_id" "namenlos"]
            set uname [::tlf_cassignments::get_user_name -user_id $stud]
            append html "<div class='submitter'>$uname "
            if {[permission::permission_p -object_id [$obj set package_id] -privilege "admin"]} {
                append html "([_ tlf-assignments.group] <a href='groupmgr?a=view_detail&id=$group_id&return_url=[::xo::cc set url]'>$gname</a>)</div>"
            } else {
                append html "([_ tlf-assignments.group] $gname)</div>"
            }
            return [list html $html ff $ff]
        }


    if {[set sd [$obj get_property -name submission_date]] ne ""} {
        append html "<div class='submission-title'>[_ tlf-assignments.cur_sub] [clock format $sd -format {%d.%m.%Y %H:%M}]</div>"
    } else {
       append html "<div class='submission-title'>[_ tlf-assignments.cur_sub]</div>"
    }
    set uname [::tlf_cassignments::get_user_name -user_id $stud]
    append html "<div class='submitter'>$uname</div>"

    return [list html $html ff $ff]
}

SubmissionType=file instproc render_preview {{-view_only 0} submission} {
    if {$view_only} {
         set abgabe "<a href='[$submission pretty_link]?view_method=view'>[_ tlf-assignments.details]</a>"
    } else {
        set abgabe "<a href='[$submission pretty_link]'>[_ tlf-assignments.details]</a>"
    }
    return $abgabe
}

SubmissionType=file instproc grading_form {obj} {
        set gradehtml ""
        set grade_fc ""
    if {[::xo::cc role=admin -user_id [::xo::cc user_id] -package_id [$obj package_id]]} {
            set gradehtml "
            <div class='submission-title'>[_ tlf-assignments.grading]</div>
            @supervisorcomment@
            @grade@
            @superfile@
            "
            append grade_fc "
            {superfile:pretty_file,label=#tlf-assignments.file_upload#,size=10}
            {supervisorcomment:textarea,label=#tlf-assignments.supercomment#}
            "
        }

    return [list form $gradehtml ff $grade_fc]
}

SubmissionType=file instproc graded_form_html {obj ast} {
    set link ""
    for {set i 1} {$i < 6} {incr i} {
        if {[$obj get_property -name file$i] ne "" } {
            append link "@file$i@\n"
        }
    }

    set ff "{comment:label,label=}
    {file1:pretty_file,disabled,label=#tlf-assignments.subm#}
    {supervisorcomment:label,label=}"
    return [list link $link ff $ff]
}

SubmissionType=file proc workflow_definition {} {
    return {
        ${:object} mixin add ButtonCancelMixin
        State parameter [list {view_method edit}]
        State initial -form_loader abgabe_initial
        initial proc actions {} {
            return [${:object} check_submittable]
        }
        Action initialize
        Action submit -label  [_ tlf-assignments.abgabe_submit] \
            -next_state submitted -proc activate {obj} {$obj dosubmit}
        Action cancel -proc activate {obj} {$obj delete} \
            -label [_ tlf-assignments.abgabe_cancel]
        Action upload -next_state initial  \
            -label [_ tlf-assignments.abgabe_upload]
        Action grade_again -next_state grade_state \
            -label [_ tlf-assignments.abgabe_grade_again]
        Action grade -next_state graded \
            -label [_ tlf-assignments.abgabe_grade] \
            -proc activate {obj} {$obj grading_done}
        Action returnforsubmission -next_state resubmission \
            -label [_ tlf-assignments.abgabe_returnforsubmission]
        Action dograding -next_state grade_state \
            -label [_ tlf-assignments.abgabe_dograding]
        Action doresubmission -next_state initial \
            -label [_ tlf-assignments.abgabe_doresubmission] \
            -proc activate {obj} {$obj do_resubmission}


        State submitted -in_role admin {
            -actions {dograding returnforsubmission}
        } -form_loader {abgabe_submitted}

        #disable grade_again for now
        State graded -in_role admin {
            -actions {grade_again}
        } -form_loader {abgabe_graded}

        State resubmission -in_role admin {
            -actions doresubmission -form_loader abgabe_submitted
        } -form_loader abgabe_resubmission

        State grade_state -in_role admin {
            -actions grade -form_loader abgabe_submitted
        } -form_loader abgabe_grade
    }
}

######################################################
# SubmissionType=Ot
######################################################
Class create SubmissionType=ot -superclass GenericSubmissionType -parameter {  }
SubmissionType=ot set allow_download 0
SubmissionType=ot set rating_needed 1
SubmissionType=ot set allow_resub 0
SubmissionType=ot set allow_regrade 0
SubmissionType=ot set allowQuickGrade 0
SubmissionType=ot proc asOption {} {
    return {{#tlf-assignments.otex#} {ot}}
}

SubmissionType=ot proc elegible_types {} {
    return [list "alle" "einzelne" "gruppe"]
}

SubmissionType=ot instproc form_info {obj ast} {
                set form_info_final ""
                set abgabe "
                <div class='table-wizard'>
                    <div class='tr'>
                    <div class='td active'>[_ tlf-assignments.ot_step1]</div>
                    <div class='td grey'>[_ tlf-assignments.ot_step2]</div>
                    </div>
                    </div>
                    @answer@"
    return [list subm $abgabe form_info_final $form_info_final fc ""]
}

SubmissionType=ot instproc render_preview {{-view_only 0} submission } {
    if {$view_only} {
        set abgabe "<a href='[$submission pretty_link]?view_method=view'>[_ tlf-assignments.details]</a><br>"
    } else {
        set abgabe "<a href='[$submission pretty_link]'>[_ tlf-assignments.details]</a><br>"
    }
    append abgabe "<p class='percent85'>Antwort: [$submission get_property -name answer]<br>
    <p class='percent85'>Kommentar: [$submission get_property -name comment]<br>
     bvar: [format %.2f [$submission get_property -name bvar -default 0]]<br>
     evar: [format %.2f [$submission get_property -name evar -default 0]]<br>
     qvar: [format %.2f [$submission get_property -name qvar -default 0]]<br>
     tvar: [$submission get_property -name tvar]<br>
     #tlf-assignments.plagcheck_match#: [$submission get_property -name ldist]<br>
     ratings: [llength [$submission get_property -name ratings]]"
    return $abgabe
}

SubmissionType=ot instproc special_submit_action {obj} {
    set j 0
    set items [$obj get_ot_answers]
    foreach i $items {
        array set item_ia [$i instance_attributes]
        $obj set_property -new 1 rateitem[incr j] $item_ia(answer)
        lappend fetched_item_ids [$i item_id]
        array unset item_ia
        if {$j > 2} {break}
    }
    #$obj set_property -new 1 your_answer [$obj property answer]
    $obj set_property -new 1 fetched_item_ids $fetched_item_ids
}

SubmissionType=ot instproc post_grading_action {obj} {
        #calculate new qvar based on teachers' assessment
        set bvar [$obj get_property -name bvar -default ""]
        set tvar [expr {[$obj get_property -name grade]/10.0}]
        set newqvar [expr {($bvar + $tvar)/2}]
        set ast_id [$obj get_property -name assignment_id]
        set modus [::xo::dc get_value get_mode "select (hkey->'modus')
                                        from xowiki_form_pagei bt, cr_items ci
                                        where bt.item_id = :ast_id
                                        and bt.revision_id = ci.live_revision
                                        and ci.item_id = bt.item_id"]
        set grade ""
        switch $modus {
            note {
                set grade 5
                if {$newqvar > 0.5} {
                    set grade 4
                } elseif {$newqvar > 0.6} {
                    set grade 3
                } elseif {$newqvar > 0.7} {
                    set grade 2
                } elseif {$newqvar > 0.8} {
                    set grade 1
                }
            }
            percent {
                set grade [expr {ceil(($newqvar/1)*100)}]
            }
            passed {
                if {$newqvar > 0.5} {
                    set grade "[_ tlf-assignments.passed]"
                } else {
                    set grade "[_ tlf-assignments.not_passed]"
                }
            }
            points {
                set maxpoints [::xo::dc get_value get_points "select (hkey->'points')
                    from xowiki_form_pagei bt, cr_items ci
                    where bt.item_id = :ast_id
                    and bt.revision_id = ci.live_revision
                    and ci.item_id = bt.item_id" 0]
                if {$maxpoints eq "0"} {
                    set maxpoints 10
                }
                set grade [format %.2f [expr {$newqvar*$maxpoints}]]
            }
        }
        $obj set_property -new 1 tvar $tvar
        $obj set_property qvar $newqvar
        $obj set_property grade $grade
        ns_log notice "i have been graded qvar $newqvar tvar $tvar"
        #$obj set_property grade [string range [expr {$newqvar*10.0}] 0 3]
        #do a first level recursion
        foreach ratingitem [$obj get_property -name ratings] {
            ns_log notice "grading_ot: item has been rated by $ratingitem"
            foreach {value item} $ratingitem {
                ::xo::db::CrClass get_instance_from_db -item_id $item
                ns_log notice "grading_ot: doing recalc basevalues for item $item"
                $item calc_basevalues_ot [$item get_property -name fetched_item_ids]
                $item save
            }
        }
}

SubmissionType=ot instproc grading_form {obj} {
    set user [::tlf_cassignments::get_user_name -user_id [$obj get_property -name creator_id]]
    set litem [$obj get_property -name ldist_item]
    set lanswer ""
    if {[string is integer $litem] && $litem > 0} {
        ::xo::db::CrClass get_instance_from_db -item_id $litem
        set lanswer [$litem get_property -name answer]
    }
    set formvars "
     <div class='submission-title margin-top-1'>Mögliches Plagiat</div>
            $lanswer
            <hr><div class='submission-title'>[_ tlf-assignments.subm]</div>
            <div class='submitter'>$user</div>
            @rateitem1@
            @rateitem1_scale@
            @rateitem2@
            @rateitem2_scale@
            @rateitem3@
            @rateitem3_scale@
            @ldist@
            <div class='submission-title margin-top-1'>[_ tlf-assignments.grading]</div>
            @grade@
            @supervisorcomment@
        "

        set fc  "
            {file1:pretty_file,disabled,label=#tlf-assignments.subm#}
            @cr_fields:hidden
            group_id:hidden
            comment:label,label=#tlf-assignments.comment#
            {supervisorcomment:textarea,label=#tlf-assignments.supercomment#,admin?:hidden}
            assignment_id:hidden
            {rateitem1_scale:label,label=,admin?:hidden}
            {rateitem2_scale:label,label=,admin?:hidden}
            {rateitem3_scale:label,label=,admin?:hidden}
            {rateitem1:richtext,disabled=1,label=#tlf-assignments.rated_ans# 1,admin?:hidden}
            {rateitem2:richtext,disabled=1,label=#tlf-assignments.rated_ans# 2,admin?:hidden}
            {rateitem3:richtext,disabled=1,label=#tlf-assignments.rated_ans# 3,admin?:hidden}
            {answer:richtext,disabled=1,label=#tlf-assignments.subm_ans#}
            {grade:scale,n=10,\
            label=#tlf-assignments.admin_rate#,admin?required:hidden,\
            help_text=#tlf-assignments.admin_rate_help#}
            {supervisorcomment:richtext,
                editor=ckeditor4,
                label=#tlf-assignments.supercomment#,
                toolbar=Minimal,
                customConfig=/resources/tlf-assignments/ck_config_minimal.js,
                extraPlugins=,
                admin?:hidden}
            {ldist:label,label=#tlf-assignments.plagcheck_match#}
        "
    return [list form $formvars ff $fc]
}

SubmissionType=ot instproc submission_form_html {obj ast} {
    set qvar [$obj get_property -name bvar]
    append html "<div class='submission-title'>#tlf-assignments.subm#"
    if {[set sd [$obj get_property -name submission_date]] ne ""} {
        append html " [clock format $sd -format {%d.%m.%Y %H:%M}]"
    }
    append html "</div>"
    set stud [$obj get_property -name creator_id]
    set uname [::tlf_cassignments::get_user_name -user_id $stud]
    append html "<div class='submitter'>$uname</div>"
    append html "@answer@"
    if {[permission::permission_p -object_id [$obj set package_id] -privilege "admin"]} {
        append html "<div class='form-item-wrapper'>
                        <div class='form-label'>
                            <label>#tlf-assignments.pre_grade#</label>
                        </div>
                        <div class='form-widget'>[string range [expr {$qvar*10}] 0 3] von 10
                        </div>
                    </div>"
    }
    append html "<br>"
    return [list html $html ff ""]
}


SubmissionType=ot instproc graded_form_html {obj ast} {
                set link "@answer@"
                set ff "{answer:richtext,disabled=1,label=#tlf-assignments.subm_ans#}"
                set amiadmin [permission::permission_p -object_id [$obj set package_id] -privilege "admin"]
                if {$amiadmin} {
                    append link "
                        @bvar@
                        @tvar@"
                    append ff "
                        {bvar:label,label=#tlf-assignments.rating_stud#}
                        {tvar:label,label=#tlf-assignments.rating_admin#}
                    "
                }
                append ff "
                {supervisorcomment:richtext,disabled=1,label=#tlf-assignments.supercomment#}
                {comment:label,label=#tlf-assignments.comment#}"
            return [list link $link ff $ff]
            }

SubmissionType=ot proc workflow_definition {} {
    return {
     ${:object} mixin add ButtonCancelMixin
	State parameter [list {view_method edit}]
	State initial -form_loader abgabe_initial
        initial proc actions {} {
            return [${:object} check_submittable]
       }
    Action initialize
    Action submit -proc activate {obj} {$obj dosubmit} \
        -label  [_ tlf-assignments.abgabe_weiter] \
        -next_state rate
    Action cancel -proc activate {obj} {$obj delete} -label [_ tlf-assignments.abgabe_cancel]
    Action do_rating -next_state submitted -label [_ tlf-assignments.abgabe_do_rating] \
    -proc activate  {obj} {$obj do_rating}
    Action grade_again -next_state submitted -label [_ tlf-assignments.abgabe_grade_again]
    Action grade -next_state graded -label [_ tlf-assignments.abgabe_grade] -proc activate {obj} {$obj grading_done}
    Action dograding -next_state grade_state -label [_ tlf-assignments.abgabe_dograding]
 State submitted -in_role admin {
         -actions dograding
    } -form_loader {abgabe_submitted}
    State graded -in_role admin {
        -actions {grade_again}
    } -form_loader {abgabe_graded}
  State rate -actions {do_rating} -form_loader rating_form
  State grade_state -in_role admin {
    -actions grade
    } -form_loader abgabe_grade
  }
}


######################################################
# SubmissionType=Textarea
######################################################
Class create SubmissionType=textarea -superclass GenericSubmissionType -parameter {}
SubmissionType=textarea set allow_download 1
SubmissionType=textarea set rating_needed 0
SubmissionType=textarea set allow_resub 1
SubmissionType=textarea set allow_regrade 1
SubmissionType=textarea set allowQuickGrade 1
SubmissionType=textarea proc asOption {} {
    return {{#tlf-assignments.textex#} {textarea}}
}

SubmissionType=textarea proc elegible_types {} {
    return [list "alle" "einzelne" "gruppe"]
}

SubmissionType=textarea instproc form_info {obj ast} {
    set subm "
   @answer@
   "
    set form_info_final "
    <div class=\"form-help-text\">
    <img width=\"12\" height=\"9\" border=\"0\" style=\"margin-right: 5px\" title=\"Help text\" src=\"/shared/images/info.gif\">
    [_ tlf-assignments.abgabe_help]</div>"
    set fc "
     {answer:richtext,disabled,label=#tlf-assignments.subm#}
    "

    return [list subm $subm form_info_final $form_info_final fc $fc]
}

SubmissionType=textarea instproc submission_form_html {obj ast} {
    set ff "@answer@"

    #append html [$obj collect_submissions]
    #append html "<div class='submission-title'>Aktuelle Abgabe</div>"
    set stud [$obj get_property -name creator_id]
      if {[$ast get_property -name groups] ne ""} {
                    set group_id [$obj get_property -name group_id]
            if {[set sd [$obj get_property -name submission_date]] ne ""} {
                append html "<div class='submission-title'>[_ tlf-assignments.cur_sub] [clock format $sd -format {%d.%m.%Y %H:%M}]</div>"
            } else {
               append html "<div class='submission-title'>[_ tlf-assignments.cur_sub]</div>"
            }
            set gname [::xo::dc get_value group_name "select group_name from groups where group_id = :group_id" "namenlos"]
            set uname [::tlf_cassignments::get_user_name -user_id $stud]
            append html "<div class='submitter'>$uname "
            if {[permission::permission_p -object_id [$obj set package_id] -privilege "admin"]} {
                append html "([_ tlf-assignments.group] <a href='groupmgr?a=view_detail&id=$group_id&return_url=[::xo::cc set url]'>$gname</a>)</div>"
            } else {
                append html "([_ tlf-assignments.group] $gname)</div>"
            }
            return [list html $html ff $ff]
        }


    if {[set sd [$obj get_property -name submission_date]] ne ""} {
        append html "<div class='submission-title'>[_ tlf-assignments.cur_sub] [clock format $sd -format {%d.%m.%Y %H:%M}]</div>"
    } else {
       append html "<div class='submission-title'>[_ tlf-assignments.cur_sub]</div>"
    }
    set uname [::tlf_cassignments::get_user_name -user_id $stud]
    append html "<div class='submitter'>$uname</div>"

    return [list html $html ff $ff]
}

SubmissionType=textarea instproc render_preview {{-view_only 0} submission} {
    if {$view_only} {
        set abgabe "<a href='[$submission pretty_link]?view_method=view'>[_ tlf-assignments.details]</a>"
    } else {
        set abgabe "<a href='[$submission pretty_link]'>[_ tlf-assignments.details]</a>"
    }
    # bugfix #17043: convert submission-text to text in order to avoid broken listings
    append abgabe "
     <p class='percent85'>[_ tlf-assignments.subm_ans]: [string range [ad_convert_to_text [$submission get_property -name answer]] 0 500] <br>"
     if {[string length [$submission get_property -name answer]] > 500} {
        append abgabe "(...)"
      }
    return $abgabe
}

SubmissionType=textarea instproc grading_form {obj} {
        set gradehtml ""
        set grade_fc ""
    if {[::xo::cc role=admin -user_id [::xo::cc user_id] -package_id [$obj package_id]]} {
            set gradehtml "
            <div class='submission-title'>[_ tlf-assignments.grading]</div>
            @supervisorcomment@
            @grade@
            @superfile@
            "
            append grade_fc "
            {answer:richtext,disabled,label=#tlf-assignments.subm_ans#}
            {superfile:pretty_file,label=#tlf-assignments.file_upload#,size=10}
            {supervisorcomment:textarea,label=#tlf-assignments.supercomment#}
            "
        }

    return [list form $gradehtml ff $grade_fc]
}

SubmissionType=textarea instproc graded_form_html {obj ast} {
    set link "@answer@"
    set ff "
    {answer:richtext,disabled,label=#tlf-assignments.subm_ans#}
    {comment:label,label=}
    {supervisorcomment:label,label=}"
    return [list link $link ff $ff]
}

::xo::library source_dependent
#
# Local variables:
#    mode: tcl
#    tcl-indent-level: 4
#    indent-tabs-mode: nil
# End:
