ad_library {
    tlf-assignment workflow-related methods.  For workflows see
    www/resources/prototypes/create-assignment.wf

    @creation-date 2011-02-28
    @author Markus Moser
}

##::xo::db::require package xowf
::xo::library require -package xowf xowf-procs

namespace eval ::xowf {

    Class create AssignmentCoreWFprocs

    AssignmentCoreWFprocs instproc www-submit {} {
        #create a formpage = group has submitted
        #init form_page with ia, save ia to hstore
        #work on assignment object [get id and group]
        #properties needed: assignment id, group id, score, revisioning
        set user_id [::xo::cc set user_id]
        set package_id ${:package_id}
        set amiadmin [permission::permission_p \
            -object_id $package_id \
            -privilege "admin" \
            -party_id $user_id \
            -no_cache]
        set group [:checkgroup $user_id]
        set query_user_id [::xo::cc query_parameter user_id 0]
        set foreign_user [expr { $query_user_id ne 0 && $amiadmin ? $query_user_id : 0 }]
        if {$foreign_user ne 0} {
            set group_id $foreign_user
            set amiadmin 0
        } else {
            set group_id [lindex $group 1]
        }
        set name abgabe_${:item_id}__${group_id}
        set exists_p [$package_id lookup -name $name]

        if {$exists_p eq 0} {
            set template [string trimleft [$package_id resolve_page abgabe-stud.wf method_var] :]
            set ia [subst {note "" \
                exercise_form [:get_property -name exercise_form] \
                assignment_id ${:item_id} \
                group_id $group_id \
                creator_id $user_id \
                graded 0 \
                amiadmin $amiadmin \
                foreign_user $foreign_user}]
            set abgabeseite [::xowiki::FormPage new -noinit \
              -set instance_attributes $ia \
              -set package_id $package_id \
              -set name $name\
              -set title #tlf-assignments.Submission# \
              -set page_template $template \
              -set publish_status ready \
              -set parent_id [$package_id set folder_id] \
                -set state initial]
            $abgabeseite save_new
            $abgabeseite initialize_loaded_object
            $abgabeseite destroy
        }

        set display_members [parameter::get -package_id $package_id -parameter member_display -default 0]
        set comm_clause [expr {$display_members ? "-community_id [dotlrn_community::get_community_id]" : "" }]
        #view
        $package_id returnredirect $name
    }

    AssignmentCoreWFprocs instproc -deprecated submit {args} {
        ad_log warning "????? - who is calling me?"
        :www-submit {*}$args
    }

    AssignmentCoreWFprocs instproc www-foreign_submit {} {
        set foreign_user [::xo::cc query_parameter user_id]
        if {$foreign_user ne "" } {
            :set_property -new 1 foreign_user $foreign_user
            set s [:find_slot instance_attributes]
            :update_attribute_from_slot -revision_id "${:revision_id}" $s ${:instance_attributes}
            :save_in_hstore
            my www-edit
        } else {
            :www-edit
        }
    }

    AssignmentCoreWFprocs instproc -deprecated foreign_submit {args} {
        ad_log warning "????? - who is calling me?"
        :www-foreign_submit {*}$args
    }

    AssignmentCoreWFprocs ad_instproc -private www-bulk_grade {} {
        Bulk grade all values. This only get called by an ajax call
        with a redirect callback, so there is no need to redirect or
        return more than a status code.
    } {
        set values [split [ns_queryget values] ,]
        set package_id ${:package_id}
        set error 0
        foreach {submission grade} $values {
            set sub_id [::xo::db::CrClass get_instance_from_db -item_id $submission]
            set ast [$sub_id get_property -name assignment_id]
            GradingType=[$ast get_property -name modus] create [self]::gtype
            set maxpoints [$ast get_property -name points]
            set is_valid [[self]::gtype validateInput [list $grade $maxpoints]]
            if {$is_valid} {
                set creator [$sub_id get_property -name creator_id]
                $sub_id set_property -new 1 graded 1
                $sub_id set_property -new 1 grade $grade
                $sub_id set_property -new 1 grading_date [clock seconds]
                $sub_id set_property -new 1 beurteiler [::xo::cc set user_id]
                $sub_id set state graded
                $sub_id save -modifying_user $creator
            } else {
                #util_user_message -message "Wert $grade ist ungültig."
                set error 1
            }
        }
        set display_members [parameter::get -package_id $package_id -parameter member_display -default 0]
        set comm_clause [expr {$display_members ? "-community_id [dotlrn_community::get_community_id]" : "" }]
        if {$error} {
            ad_returnredirect ".?view=${:item_id}&type=submitted"
            ad_script_abort
        #ns_return 200 text/plain "values=$values names=$names"
        }
        ns_return 200 text/plain ""
        ad_script_abort
    }

    AssignmentCoreWFprocs instproc -deprecated bulk_grade {args} {
        ad_log warning "????? - who is calling me?"
        :www-bulk_grade {*}$args
    }

    AssignmentCoreWFprocs instproc www-bulk_download {} {
        package req nx::zip
        set item_ids [ns_querygetall item_id]
        #gather all submissions
        if {[llength $item_ids] == 0} {
            :msg "nothing selected"
            ${:package_id} returnredirect [:query_parameter "return_url"]
            return 0
        }
        set z [::nx::zip::Archive new]

        set package_id ${:package_id}
        set parent_id [$package_id set folder_id]
        set page_template [string trimleft [$package_id resolve_page abgabe-stud.wf method_var] :]
        set item_id ${:item_id}
        set allsubmissions [::xo::dc list_of_lists get_submissions {
            select item_id as sub_item_id,
                   hkey->'group_id' as uid,
                   hkey->'answer' as answer,
                   hkey->'solution' as solution,
                   hkey->'comment' as comment,
                   hkey->'proto_solution.pdf' as proto_solution_pdf,
                   (select title from cr_revisions
                    where revision_id = (select live_revision
                                         from cr_items
                                         where item_id = item.item_id)) as sub_title,
                   (select creation_date from acs_objects
                    where object_id = item.item_id) as creation_date
            from xowiki_form_instance_item_index item
            where parent_id = :parent_id
              and page_template = :page_template
              and package_id = :package_id
              and state <> 'initial'
              and publish_status = 'ready'
              and hkey->'assignment_id' = :item_id
              and item_id = ANY(cast(string_to_array(:item_ids, ' ') as integer[]))
            order by creation_date desc
        }]

        if {[llength $allsubmissions] == 0} {
            util_user_message -message "[_ tlf-assignments.export_nothing]"
            ad_returnredirect [$package_id pretty_link -parent_id [$package_id folder_id] index]
            ad_script_abort
        }
        set root_dir [ns_mktemp /tmp/hwnXXXXXX]
        # create temporary directory
        file mkdir $root_dir

        foreach sub $allsubmissions {
            lassign $sub sub_item_id uid answer solution comment proto_solution_pdf sub_title creation_date

            set username [string trimleft [::xo::dc get_value uname "select last_name ||'_'|| first_names ||'_'|| username from acs_users_all where user_id = :uid"  0] h]
            if {$username eq 0} {
                set username [::xo::dc get_value groupname "select group_name from groups where group_id = :uid" "unbekannt"]
            }
            # fmoedrit/hotfix: ignore files without live_revision (corrupt items!)
            foreach item [::xo::dc list itemlist {
                select item_id from cr_items
                where parent_id = :sub_item_id
                  and content_type = '::xowiki::File'
                  and live_revision is not null
            }] {
                ::xo::db::CrClass get_instance_from_db -item_id $item
                set title [$item set title]
                if {[string length $title] > 160 } {
                    if {![regexp {\.([a-zA-z0-9]{3,4})$} $title extension match]} {
                    set extension ""
                    }
                    set title "[string range $title 0 160]$extension"
                }
                set filename ${username}_$title
                regsub -all {\\|\/|\:|\*|\?|\"|<|>|\|} $filename "" filename
                $z addFile  [cr_fs_path][$item set text] $filename
            }
            if {$comment ne ""} {
                $z addString $comment ${username}_comment.txt
            }
            #subcase: answer fields
            if {$answer ne ""} {
                set filename ${username}_${:title}.txt
                regsub -all {\\|\/|\:|\*|\?|\"|<|>|\|} $filename "" filename
                $z addString $answer $filename
            }
        }
        #create a zip file and clean up
        regsub -all {\\|\/|\:|\*|\?|\"|<|>|\|} ${:title} "" cleantitle
        $z ns_returnZipFile $cleantitle.zip
        $z destroy
        file delete $root_dir
        ad_script_abort
    }

    AssignmentCoreWFprocs instproc -deprecated bulk_download {args} {
        ad_log warning "????? - who is calling me?"
        :www-bulk_download {*}$args
    }

    AssignmentCoreWFprocs ad_instproc -private www-render_exercise {} {
        Render this exercise. Interface for starting a submission.

        @return HTML
    } {
        set group [lindex [:checkgroup [::xo::cc user_id]] 1]
        set nf_property_name ${group}_nachfrist
        set html [:render_angabe]
        set nf [:get_property -name $nf_property_name]
        if {$nf ne ""} {
            set nf_label [_ tlf-assignments.nachfrist]
            set nf_date [:germanize_date $nf_property_name]
            append html "
            <div class='fristen'>
                <div class='table'>
                    <div class='tr'>
                        <div class='td'>${nf_label}:&nbsp;</div>
                        <div class='td'> ${nf_date}</div>
                    </div>
                </div>
            </div>"
        }

        if {[:check_submittable] ne ""} {
            set submit_url [export_vars -base [:pretty_link] {{m submit}}]
            set submit_label [_ tlf-assignments.create_instance]
            append html "<br><a class='button' href='${submit_url}'>${submit_label}</a>"
        }
        :www-view $html
    }

    AssignmentCoreWFprocs instproc -deprecated render_exercise {args} {
        ad_log warning "????? who is calling me?"
        :www-render_exercise {*}$args
    }

    AssignmentCoreWFprocs instproc www-write_nf {} {
        set year  [ns_queryget year]
        set month [ns_queryget month]
        set op    [ns_queryget op]
        set day   [ns_queryget day]
        set hour  [ns_queryget hour]
        set min   [ns_queryget minute]

        ns_log notice "write_nf called with $year-$month-$day ${hour}:${min}:00"
        if {$op eq "set_nf"} {
            set time_to [:get_property -name time_to]
            if {[catch {set ticks [clock scan "$year-$month-$day ${hour}:${min}:00"]}]} {
                set ticks 0 ;# we assume that the validator flags these values
            }
            if {[clock scan $time_to] > $ticks} {
                ad_returnredirect [ns_queryget return_url]
                util_user_message -message "[_ tlf-assignments.nachfrist_ahead]"
                ad_script_abort
            }
            set time [clock format $ticks -format "%Y-%m-%d %T"]
            set community_id [dotlrn_community::get_community_id_from_url -url [${:package_id} package_url]]
            set community_pretty_name [dotlrn_community::get_community_name $community_id]
            #build a list of affected users
            set userlist [list]
            foreach user_id [ns_querygetall item_id] {
                :set_property -new 1 ${user_id}_nachfrist $time
                if {[acs_object_type $user_id] eq "group"} {
                    # append every member of this group to the list
                    lappend userlist {*}[group::get_members -group_id $user_id -type user]
                } else {
                    lappend userlist $user_id
                }
            }

            set system_name [ad_system_name]
            set system_owner [ad_system_owner]
            set system_url [ad_url]

            foreach user $userlist {
                set link [:pretty_link -absolute 1]
                set subject "$community_pretty_name Nachfrist bei einer Aufgabe / Assignment extension"
                set body "\[please scroll down for english version\]<br><br>
                <b>Benachrichtigung: Neue Nachfrist wurde gesetzt</b> <br>
                Lehrveranstaltung: $community_pretty_name<br>
                Aufgabe: ${:title}<br>
                Ende der Nachfrist: $time <br>
              <br>Die Aufgabe finden Sie unter <a href='$link'>URL</a><br>
              <hr>
              <br>
              Bei Fragen steht Ihnen das $system_name-Team unter $system_owner zur Verfügung.
              <br><br>
              <b>Notification: New extension has been set</b><br>
              Course: $community_pretty_name<br>
              Assignment: ${:title}<br>
              End of extension: $time<br>
              <br>To view the assignment, click <a href='$link'>URL</a><br>
              <hr>
              <br>
              The $system_name team will be happy to answer your questions ($system_owner).
              "
                set email [acs_user::get -user_id $user \
                               -element email]
                acs_mail_lite::send \
                    -to_addr   $email \
                    -from_addr $system_owner \
                    -subject   $subject \
                    -body      $body \
                    -mime_type text/html
            }
        } elseif {$op eq "del_nf"} {
            set user_id [ns_querygetall item_id]
            #update todos with deadline extension
            if {[acs_object_type $user_id] eq "group"} {
                set user_id [group::get_members \
                -group_id $user_id -type user]
            }
            foreach user_id [ns_querygetall item_id] {
                :set_property -new 1 ${user_id}_nachfrist ""
            }
        } elseif {$op eq "set_resub"} {
            #set_resub is called on submission instance
            if {[catch {set ticks [clock scan "$year-$month-$day ${hour}:${min}:00"]}]} {
                set ticks 0
            }
            foreach item_id [ns_querygetall item_id] {
                ::xo::db::CrClass get_instance_from_db -item_id $item_id
                ns_log notice "setting resub for [$item_id set name] [$item_id set title]"
                set time [clock format $ticks -format "%Y-%m-%d %T"]
                $item_id set_property -new 1 resubmissionff $time
                $item_id save -modifying_user [$item_id set creation_user]
                set assignment [$item_id property assignment_id]
                ::xo::db::CrClass get_instance_from_db -item_id $assignment
                set sub_user [$item_id property group_id]
                if {[acs_object_type $sub_user] eq "group"} {
                    set user_id [group::get_members -group_id $sub_user -type user]
                } else {
                    set user_id $sub_user
                }
            }
        }
        :save
        ad_returnredirect [ns_queryget return_url]
        ad_script_abort
    }

    AssignmentCoreWFprocs instproc -deprecated write_nf {args} {
        ad_log warning "????? who is calling me?"
        :www-write_nf {*}$args
    }

    AssignmentCoreWFprocs instproc get_ot_answers {
        {-all 0}
    } {
        #set ot_mode 1 ;#use only sample answers
        set ot_mode [::parameter::get -parameter ot_mode -package_id ${:package_id} -default 0]
        if {$all} {
            set extra_clause ""
        } else {
            set extra_clause [expr {$ot_mode eq 1 ? "and (hkey->'is_sample')::boolean = 1::boolean" : ""}]
        }
        set ast [:get_property -name assignment_id]
        if {$all} {
            set distance_clause ""
        } else {
            set distance_clause "and ((hkey->'ldist')::integer < 50 or (hkey->'ldist')::integer is null) "
        }
        set template [string trimleft [${:package_id} resolve_page abgabe-stud.wf method_var] :]
        set form_fields [::xowiki::FormPage get_table_form_fields \
            -base_item $template \
            -field_names answer,qvar,evar,bvar,revision_id,ratings \
            -form_constraints " "]
        set items [[::xowiki::FormPage get_form_entries -base_item_ids $template \
            -package_id ${:package_id} \
            -form_fields $form_fields \
            -publish_status "all" \
            -always_queried_attributes {_revision_id _item_id _page_id _object_id _creator} \
            -initialize true \
            -extra_where_clause "
                and state in ('graded', 'submitted')
                and (hkey->'assignment_id')::text = '$ast'
                and (hkey->'exercise_form')::text = 'ot'
                and ( hkey->'amiadmin' is null or cast(hkey->'amiadmin' as boolean) is false )
                $extra_clause $distance_clause" \
            -orderby "coalesce(length((hkey->'ratings')::text),0::integer) asc"
            ] children]

        #shuffle the results
        #foreach item $items {::xo::cc msg [$item get_property -name answer]; ::xo::cc msg [$item get_property -name ratings]}
        for {set i 1} {$i <[llength $items]} {incr i} {
            set j [expr {int(rand()*[llength $items])}]
            set tmp [lindex $items $i]
            lset items $i [lindex $items $j]
            lset items $j $tmp
        }
        #my msg "xolrn_cf: got [llength $items]"
        return $items
    }

    AssignmentCoreWFprocs ad_instproc -private checkgroup {
        user_id
    } {
        Is the user a member of a group assigned to this instance?
    } {
        set isgroup [:get_property -name groups -default ""]
        set islimited [:get_property -name bearbeiter -default ""]
        if {$isgroup ne ""} {
            foreach group $isgroup {
                set is_member [group::member_p -user_id $user_id -group_id $group -cascade]
                if {$is_member} {
                    return [list 1 $group]
                }
            }
            return [list 0 0]
        } elseif {$islimited ne ""} {
            if {$user_id in [:get_property -name bearbeiter]} {
                return [list 1 $user_id]
            } else {
                return [list 0 0]
            }
        } else {
            return [list 0 $user_id]
        }
    }

    AssignmentCoreWFprocs ad_instproc -private dosubmit {} {
        Check if another user has opened this at the same time and
        submitted before me.
    } {
        set ctx [::xowf::Context require ${:item_id}]
        if { [$ctx get_current_state] ne "initial"} {
            :msg "[_ tlf-assignments.already_submitted]"
            [${ctx}::submit] set next_state initial
        } else {
            if {[:get_property -name exercise_form] ne "ot"} {
                util_user_message -message "[_ tlf-assignments.submitted_success]"
            }
            SubmissionType=[:get_property -name exercise_form] [self]::stype
            [self]::stype special_submit_action ${:item_id}
            set ast [:get_property -name assignment_id]
            set uname [::xo::cc user_id]
            ::xo::db::CrClass get_instance_from_db -item_id $ast
            :set_property -new 1 creator_id $uname
            :set_property -new 1 submission_date [clock seconds]
            #set todo
            set group [:property group_id]
            if {[acs_object_type $group] eq "group"} {
                set uname [group::get_members -group_id $group -type user]
            }
            #foreign submits!
            set foreign_user [:get_property -name foreign_user]
            if {$foreign_user ni {"" 0}} {
                set uname $foreign_user
            }
        }
    }

    AssignmentCoreWFprocs instproc check_submittable {
        {admin_priv "0"}
    } {
        if {
            ([::xo::cc query_parameter user_id 0] ne 0 || [:get_property -name foreign_user] ne "")
            &&
            [::xo::cc permission -object_id [::xo::cc set package_id] -privilege admin -party_id [::xo::cc user_id]]
        } {
            return "submit"
        }

        set exercise_form [:get_property -name exercise_form]
        set auto_handin [expr {[SubmissionType=${exercise_form} auto_handin] eq 1}]
        if {[SubmissionType=${exercise_form} allow_draft] eq 1} {
            set actions {submit upload}
        } else {
            set actions {submit}
        }
        if {
            $admin_priv
            &&
            [::xo::cc permission -object_id [::xo::cc set package_id] -privilege admin -party_id [::xo::cc user_id]]
        } {
            return $actions
        }
        if { [set resub [:get_property -name resubmissionff]] ne ""} {
            if {[clock seconds] < [clock scan $resub]} {
                return $actions
            } else {
                return ""
            }
        }
        set ast [:get_property -name assignment_id]
        if {$ast eq ""} {
            set ast ${:item_id}
        }
        ::xo::db::CrClass get_instance_from_db -item_id $ast
        set id [lindex [$ast checkgroup [::xo::cc user_id]] 1]
        if {
            $id == 0
            &&
            ![::xo::cc permission -object_id [::xo::cc set package_id] -privilege admin -party_id [::xo::cc user_id]]
        } {
            return ""
        }
        set nf [$ast get_property -name ${id}_nachfrist]
        if {$nf ne ""} {
            if {[clock scan $nf] > [clock seconds]} {
                if {$auto_handin} {
                    return " "
                } else {
                    return $actions
                }
            } else {
                return ""
            }
        }

        set ast_start [expr {[clock scan [$ast get_property -name time_from]] < [clock seconds]}]
        set ast_end [expr {[clock seconds] > [clock scan [$ast get_property -name time_to]]}]
        set is_enabled [expr {$ast_start && !$ast_end}]
        if {!$is_enabled} {
            return ""
        } elseif {$auto_handin} {
            return " "
        } else {
            return $actions
        }
    }


    AssignmentCoreWFprocs instproc check_grade_vis {} {
        set package_id ${:package_id}
        switch [:get_property -name beurteilung] {
            sofort {
                return 1
            }
            date {
            #to be tested
                set cdate [:get_property -name release_date]
                return [expr {[clock seconds] > [clock scan $cdate]}]
            }
            keine {
                return 0
            }
            korrektur {
                set cdate [:get_property -name time_to]
                array set subm [:calc_submissions]
                if {$subm(submitted) eq 0
                    && $subm(graded) > 0
                    && [clock seconds] > [clock scan $cdate]
                } {
                    array unset subm
                    return 1
                }
                return 0
                array unset subm
            }
            individual {
                return [expr {[:get_property -name grade_released] ne ""}]
            }
        }
    }

    AssignmentCoreWFprocs instproc saveZB {} {
        #placeholder
    }

    AssignmentCoreWFprocs instproc update_cal {} {
        #placeholder
    }

    AssignmentCoreWFprocs instproc do_rating {} {
        set item_ids [:get_property -name fetched_item_ids]
        foreach id $item_ids {
            catch {lappend items [::xo::db::CrClass get_instance_from_db -item_id $id]}
        }
        :calc_basevalues_ot $items
        :set_property -new 1 creator_id [::xo::cc user_id]
        set display_members [parameter::get -package_id ${:package_id} -parameter member_display -default 0]
        set comm_clause [expr {$display_members ? "-community_id [dotlrn_community::get_community_id]" : "" }]
        util_user_message -message "[_ tlf-assignments.submitted_success]"
    }

    AssignmentCoreWFprocs instproc upload_done {} {
         set amiadmin [permission::permission_p -object_id ${:package_id} -privilege "admin"]
         if {!$amiadmin} {
            util_user_message -message "[_ tlf-assignments.draft_success]."
            util_user_message -message "[_ tlf-assignments.draft_not_submitted_automatically]"
         }
    }

    AssignmentCoreWFprocs instproc grading_done {} {
        SubmissionType=[:get_property -name exercise_form] create [self]::stype
        [self]::stype post_grading_action ${:item_id}
        :set_property -new 1 grading_date [clock seconds]
        :set_property -new 1 beurteiler [::xo::cc set user_id]
        :set_property graded 1
        ::xo::cc set_parameter return_url ".?view=[:get_property -name assignment_id]&type=submitted"
        util_user_message -message "[_ tlf-assignments.grade_success]."
    }

    AssignmentCoreWFprocs instproc do_resubmission {} {
        :set_property graded 0
        set files ""
        set answer [:get_property -name answer]
        set page [:get_property -name page]
        #write submission log
        for {set i 1} {$i < 6} {incr i} {
            set file [join [:get_property -name file$i]]
            if {[llength $file] > 2 && [llength $file] % 2 eq 0} {
                array set file_array $file
                if {[info exists file_array(name)]} {
                    set file $file_array(name)
                }
            }

            if {$file ne ""} {
                set fi [[::xo::cc set package_id] lookup -name file:file$i -parent_id ${:item_id}]
                if {[info exists file_array(revision_id)]} {
                    set live_revision $file_array(revision_id)
                } else {
                    set live_revision [::content::item::get_live_revision -item_id $fi]
                }
                append files "<a href='[[::xo::cc package_id] pretty_link -download 1 -parent_id ${:item_id} file$i]?revision_id=$live_revision&filename=[ns_urlencode $file]'>$file</a><br>"
            }
        }
        set subm_log [:get_property -name submission_log]
        set creator  [::tlf_cassignments::get_user_name -user_id [:get_property -name creator_id]]
        set subm_date [clock format [:get_property -name submission_date] -format  {%d.%m.%Y %H:%M}]
        set comm_log ""
        set supercomm_log ""

        if {[set com [:get_property -name comment]] ne ""} {
            regsub -all {(<|>)} $com {} com
            set comm_log {<div class=\"form-item-wrapper\">
                             <div class=\"form-label old\">
                                 \#tlf-assignments.my_comment\#:
                             </div>
                             <div class=\"form-widget\">
                                 $com
                             </div>
                         </div>}
        }
        if {[set sc [:get_property -name supervisorcomment]] ne ""} {
            regsub -all {(<|>)} $sc {} sc
            set supercomm_log {
                <div class=\"form-item-wrapper\">
                    <div class=\"form-label old\">
                            \#tlf-assignments.supercomment\#:
                    </div>
                    <div class=\"form-widget\">$sc</div>
                </div>}
        }

        append subm_log {
                <div class='submission-title'>
                \#tlf-assignments.subm\# $subm_date</div>
                <div class='submitter'>$creator</div>
                <div class=\"form-item-wrapper\">
                <div class=\"form-label old\">
                    \#tlf-assignments.subm\#
                </div>
                <div class=\"form-widget\">
                    $files
                    $answer
                    $page
                </div>
                </div>
        }
        append subm_log $comm_log $supercomm_log
        set superfile [join [:get_property -name superfile]]
        if {[llength $superfile] > 2 && [llength $superfile] % 2 eq 0} {
            array set sfile_array $superfile
            if {[info exists sfile_array(name)]} {
            set superfile $sfile_array(name)
            }
        }
        if {$superfile ne ""} {
            set sfile [[::xo::cc set package_id] lookup -name file:superfile -parent_id ${:item_id}]
            if {[info exists sfile_array(revision_id)]} {
                set sfile_live_revision $sfile_array(revision_id)
            } else {
                set sfile_live_revision [::content::item::get_live_revision -item_id $sfile]
            }
            set href "[[::xo::cc package_id] pretty_link -download 1 -parent_id ${:item_id} superfile]?revision_id=$sfile_live_revision&filename=[ns_urlencode $superfile]"
            append subm_log {
                <div class=\"form-item-wrapper\">
                    <div class=\"form-label old\">
                         \#tlf-assignments.superfile\#:
                    </div>
                    <div class=\"form-widget\">
                        <a href='$href'>$superfile</a>
                    </div>
                </div>
            }
        }
        append subm_log "<br>"

        :set_property -new 1 submission_log [subst -nocommands $subm_log]
        :set_property -new 1 comment ""

        #setup notifications
        set users [:get_property -name group_id]
        if {[acs_object_type $users] eq "group"} {
            set users [group::get_members -group_id $users -type user]
        }

        set system_name [ad_system_name]
        set system_owner [ad_system_owner]
        set system_url [ad_url]

	set community_id [dotlrn_community::get_community_id_from_url -url [${:package_id} package_url]]
	set community_name [dotlrn_community::get_community_name $community_id]

        foreach user_id $users {	    
            set ast [::xo::db::CrClass get_instance_from_db -item_id [:get_property -name assignment_id]]
            set link [:pretty_link -absolute 1]
            set subject "$community_name Überarbeitungsfrist bei einer Aufgabe / Assignment resubmission"
            set body "\[please scroll down for english version\]<br><br>
            <b>Benachrichtigung: Neue Überarbeitungsfrist wurde gesetzt</b> <br>
              Lehrveranstaltung: $community_name<br>
              Aufgabe: [$ast set title]<br>
              Ende der Nachfrist: [:get_property -name resubmissionff] <br>
              <br>Die Aufgabe finden Sie unter <a href='$link'>URL</a><br><hr><br>
              Bei Fragen steht Ihnen das $system_name-Team unter $system_owner zur Verfügung.
              <br><br>
              <b>New resubmission has been set</b><br>
              Course: $community_name <br>
              Assignment: [$ast set title]<br>
              End of resubmission: [:get_property -name resubmissionff] <br>
              To view the assignment, click <a href='$link'>URL</a><br><hr><br>
              The $system_name team will be happy to answer your questions ($system_owner).
              "
            set email [acs_user::get -user_id $user_id \
                           -element email]
            acs_mail_lite::send -to_addr $email \
                -from_addr $system_owner -subject $subject -body $body -mime_type text/html
        }
        ::xo::cc set_parameter return_url ".?view=[:get_property -name assignment_id]&type=submitted"
    }

    AssignmentCoreWFprocs instproc multiple_files {id} {

        for {set i 2} {$i<=5} {incr i} {
            append html "<div id='id_${id}${i}' style='display:none'>@${id}${i}@</div>"
            if {$i > 1} {
                append script "if ( \$('#id_${id}${i} input').attr('value') != '' ) {
                    \$('#id_${id}${i}').show();
                }"
            }
        }

        set nonce [expr {[info exists ::__csp_nonce] ? "nonce=\"$::__csp_nonce\"" : ""}]
        return "$html
            <div class='form-item-wrapper'>
               <div class='form-widget'>
                  <a href='#' id='more_files'>#tlf-assignments.more_files#</a>
               </div>
            </div>
            <script type=\"text/javascript\" $nonce>
               $script
               var e = document.getElementById('more_files');
               e.addEventListener('click', function (event) {enable_upload(\"${id}\");}, false);
            </script>"
    }

    AssignmentCoreWFprocs ad_instproc -private calc_submissions {
        {returnvalue "allsubmissions"}
    } {
        Calc submissions
    } {
        set package_id ${:package_id}
        set display_members [parameter::get \
            -package_id $package_id \
            -parameter  "member_display" \
            -default    0]
        if {[ns_conn isconnected]} {
            set community_id [dotlrn_community::get_community_id]
        } else {
            set community_id [::xo::dc get_value get_comm_id {
                select min(community_id)
                  from dotlrn_community_applets
                 where package_id = :package_id
            }]
        }
        if {$display_members} {
            # set community_id [dotlrn_community::get_community_id]
            set members [::xo::dc get_value get_members {
                select count(*) as count
                from dotlrn_member_rels_approved
                where community_id = :community_id
                and rel_type in ('dotlrn_student_rel','dotlrn_member_rel')
            }]
        } else {
            set members [::xo::dc get_value get_members {
                select count(*) as count
                from dotlrn_member_rels_approved
                where community_id in (
                select community_id from dotlrn_community_applets
                where package_id = :package_id)
                and rel_type in ('dotlrn_student_rel','dotlrn_member_rel')
            }]
        }
        set add_table [expr {$display_members ? ", dotlrn_member_rels_approved m, group_member_map gm " : ""}]
        set add_query [expr {$display_members ? "and ((bt.hkey->'foreign_user')::integer in (m.user_id, gm.group_id) or ( (bt.hkey->'foreign_user')::integer = 0 and (bt.hkey->'creator_id')::integer = m.user_id) )
and gm.member_id = m.user_id
and m.community_id = $community_id" : ""}]

        # set community_id [dotlrn_comm unity::get_community_id]
        set template [string trimleft [$package_id resolve_page abgabe-stud.wf method_var] :]
        set base_id ${:item_id}

        set parent_id ${:parent_id}
        set sub_list [xo::dc list_of_lists calc_submissions_query "
        select aid, ast
            from (
                select bt.item_id as aid,
                case when bt.state in ('graded')
                        then 'graded'
                    when bt.state in ('submitted', 'grade_state', 'resubmission')
                        then 'submitted'
                    when bt.state IN ('initial', 'rate')
                        then 'open'
                end as ast,
                (bt.hkey->'graded') g,
                (bt.hkey->'amiadmin') a
            from xowiki_form_instance_item_index bt $add_table
            where page_template = :template
            and parent_id = :parent_id
            and (bt.hkey -> 'assignment_id')::integer = :base_id
            and bt.publish_status = 'ready'
            $add_query
            group by 1, 2, 3, 4) subq
            where a::boolean = false
            and ((ast = 'graded' and g::boolean = true) or ast != 'graded')"]

        set open_submissions ""
        set graded_submissions ""
        set submitted_submissions ""
        set allsubmissions ""
        foreach sub_item $sub_list {
            lassign $sub_item id state
            switch $state {
                open {
                    lappend open_submissions $id
                }
                graded {
                    lappend graded_submissions $id
                }
                submitted {
                    lappend submitted_submissions $id
                }
            }
            lappend allsubmissions $id
        }
        switch $returnvalue {
            allsubmissions {
                set rval $allsubmissions
            }
            submitted {
                set rval $submitted_submissions
            }
            graded {
                set rval $graded_submissions
            }
            open {
                set rval $open_submissions
            }
        }

        if {$returnvalue ne "allsubmissions" && $rval ne ""} {
            #we need batch init here!
            ::xowiki::FormPage instantiate_objects -sql "
            select xfi.item_id,
                   xpi.instance_attributes,
                   xfi.parent_id,
                   xfi.state,
                   xfi.page_template,
                   xfi.package_id,
                   xfi.name
              from xowiki_form_instance_item_index xfi
                inner join cr_items ci
                on ci.item_id = xfi.item_id
                inner join xowiki_page_instance xpi
                on ci.live_revision = xpi.page_instance_id
                where xfi.item_id in ([join $rval ,])" \
           -named_objects 1 -object_named_after "item_id" \
           -object_class ::xowiki::FormPage -initialize 1
        }

        set n_allsubmissions [llength $allsubmissions]
        set n_bearb [llength [:get_property -name bearbeiter]]
        set n_gr    [llength [:get_property -name groups]]
        set missing [expr {$n_bearb - $n_allsubmissions}]
        if {$n_bearb == 0} {
            set missing [expr {$members - $n_allsubmissions}]
        }
        if {$n_gr != 0} {
            set missing [expr {$n_gr - $n_allsubmissions}]
        }
        if {$missing < 0} {
            set missing 0
        }

        return [list \
            missing     $missing \
            submitted   [llength $submitted_submissions] \
            graded      [llength $graded_submissions] \
            open        [llength $open_submissions] \
            returnvalue $rval]
    }

    AssignmentCoreWFprocs instproc pp_calc_submissions {
        {-prefetch ""}
    } {
        :instvar package_id
        if {$prefetch ne ""} {
            array set subs $prefetch
        } else {
            array set subs [:calc_submissions]
        }
        set id ${:item_id}
        set type [::xo::cc query_parameter type "allsubmissions"]
        set class1 ""
        set class2 ""
        set class3 ""
        set class4 ""
        if {$type eq "missing"} {
            set class1 "font-weight:bold;"
        } elseif {$type eq "open"} {
            set class2 "font-weight:bold;"
        } elseif {$type eq "submitted"} {
            set class3 "font-weight:bold;"
        } elseif {$type eq "graded"} {
            set class4 "font-weight:bold;"
        }
        set index_link [$package_id pretty_link -parent_id [$package_id folder_id] index]
        set statusbar "
            <ul class='horizontal-list'>
              <li style='padding-right:1em;'>
                <a href='${index_link}?view=$id&type=missing' title='[_ tlf-assignments.missing]' class='abgaben n10' style='$class1'>
                  [_ tlf-assignments.missing] ($subs(missing))
                </a>
              </li>
              <li style='padding-right:1em;'>
                <a href='${index_link}?view=$id&type=open' title='[_ tlf-assignments.open]' class='abgaben n11' style='$class2'>
                  [_ tlf-assignments.open] ($subs(open))
                </a>
              </li>
              <li style='padding-right:1em;'>
                <a href='${index_link}?view=$id&type=submitted' title='[_ tlf-assignments.submitted]' class='abgaben n12' style='$class3'>
                  [_ tlf-assignments.submitted] ($subs(submitted))
                </a>
              </li>
              <li style='padding-right:1em;'>
                <a href='${index_link}?view=$id&type=graded' title='[_ tlf-assignments.graded]' class='abgaben n13' style='$class4'>
                  [_ tlf-assignments.graded] ($subs(graded))
                </a>
              </li>
            </ul>
        "

        array unset subs
        return $statusbar
    }

    AssignmentCoreWFprocs instproc calc_basevalues_ot {items} {
        ns_log notice "calc_basevalues_ot called by [:item_id] with items=$items"
        set amiadmin [permission::permission_p -object_id ${:package_id} -privilege "admin"]
        set k 0
        set sum 0.0
        set answerstorate 3.0
        # calculate basiswert for own answer

        foreach item $items {
            if {[namespace which $item] eq ""} {::xo::db::CrClass get_instance_from_db -item_id $item}
            ns_log notice "dealing with [$item name] [$item set item_id]"
            set wform [:get_property -name rateitem[incr k]_scale]
            set qitem [$item get_property -name qvar -default 0.1]
            ns_log notice "qvar is $qitem"
            set w [expr {$wform / 10.0}]
            if { (1.0 - $qitem) > $qitem } {
                set maxdivq [expr {1.0 - $qitem}]
            } else {
                set maxdivq $qitem
            }

            #vorzeichen aendern wenn negativ
            set dev [expr {$w-$qitem }]
            if {$dev < 0} {
                set dev [expr -$dev]
            }

            ns_log notice "xolrn_cf: doing calc_basevacalc_basevalues for [$item set item_id] - [$item set name] - dev=$dev, qitem=$qitem, w=$w, maxdivq=$maxdivq"
            #calculate sum
            set sum [expr {$sum + 0.0 + ($dev) / ($maxdivq)}]

            # append rating and link to solution
            if {!$amiadmin} {
                set ratings [$item get_property -name ratings]
                ns_log notice "xolrn_cf: :object id is: ${:object_id} - :ratings are $ratings - i am [$item set item_id]"
                lappend ratings "$w ${:item_id}"
                $item set_property -new 1 ratings $ratings
                set s [$item find_slot instance_attributes]
                $item update_attribute_from_slot -revision_id "[$item revision_id]" $s [$item instance_attributes]
                $item save
            }
        }
        set bvar  [expr {1.0 - (1.0 / $answerstorate) * $sum}]
        if {$bvar < 0.1} {
            ns_log notice "xolrn bug: bvar ist smaller than 0.1, resetting to 0.1"
            set bvar 0.1
        }
        ns_log notice "xolrn_cf: sum=$sum, bvar=$bvar"
        :set_property -new 1 bvar [format %.2f $bvar]
        #calculate distance
        set min_dist 0
        set min_dist_item 0
        foreach answer [:get_ot_answers -all 1] {
            set ldist [:similarity [:get_property -name answer] [$answer get_property -name answer]]
            #::xo::cc msg $ldist
            if {$ldist > $min_dist} {
                set min_dist $ldist
                set min_dist_item [$answer set item_id]
            }
        }
        :set_property -new 1 ldist $min_dist
        :set_property -new 1 ldist_item $min_dist_item

        set tvar [:get_property -name tvar -default 0]
        ns_log notice "tvar $tvar"
        if {$tvar ne 0} {
            set qvar [expr {($bvar+$tvar)/2}]
            set ast_id [:get_property -name assignment_id]
            set modus [::xo::dc get_value get_mode "select (hkey->'modus')
                                            from xowiki_form_pagei bt, cr_items ci
                                            where bt.item_id = :ast_id
                                            and bt.revision_id = ci.live_revision
                                            and ci.item_id = bt.item_id"]
            set grade ""
            switch $modus {
                note {
                    set grade 5
                    if {$qvar > 0.5} {
                        set grade 4
                    } elseif {$qvar > 0.6} {
                        set grade 3
                    } elseif {$qvar > 0.7} {
                        set grade 2
                    } elseif {$qvar > 0.8} {
                        set grade 1
                    }
                }
                percent {
                    set grade [expr {ceil(($qvar/1)*100)}]
                }
                passed {
                    if {$qvar > 0.5} {
                        set grade "[_ tlf-assignments.passed]"
                    } else {
                        set grade "[_ tlf-assignments.not_passed]"
                    }
                }
                points {
                    set maxpoints [::xo::dc get_value get_points "select (hkey->'points')
                        from xowiki_form_pagei bt, cr_items ci
                        where bt.item_id = :ast_id
                        and bt.revision_id = ci.live_revision
                        and ci.item_id = bt.item_id" 0]
                    if {$maxpoints eq "0"} {
                        set maxpoints 10
                    }
                    set grade [format %.2f [expr {$qvar*$maxpoints}]]
                }
            }
            :set_property -new 1 grade $grade
            ns_log notice "got a new grade $grade"
        } else {
            set qvar $bvar
        }
        if {$qvar < 0.1} {set qvar 0.1}
        :set_property -new 1 qvar $qvar
        ns_log notice "neuer qvar $qvar"
        :set_property -new 1 evar 0.0

        #comment the following loop to disable recalculation of the items that have been rated
        #and disable evar
        foreach item $items {
        ns_log notice "dealing with [$item name] [$item set item_id]"
            set qwsum 0.0
            set qsum 0.0
            #get current ratings of the item
            #calculate qwsum
            if {[$item get_property -name is_sample] eq 1} {
                continue
            }
            set ratings [$item get_property -name ratings]
            ns_log notice "xolrn_cf: ### recalc evar for [$item set item_id] number of ratings= [llength ratings]"
            set ratings_valid ""

            foreach rating $ratings {
                set solution_id ""
                ns_log notice "xolrn_cf: current rating=$rating "
                set w [lindex $rating 0]
                set solution_id [lindex $rating 1]
                ns_log notice "xolrn_cf: rating=$w,solution_id=$solution_id"
                set solution_item ""
                catch {set solution_item [::xo::db::CrClass get_instance_from_db -item_id $solution_id]}
                if {$solution_item ne ""} {
                    lappend ratings_valid $rating
                    set qvar_sol [$solution_item get_property -name qvar]
                    if {![string is double -strict $qvar_sol]} {
                        continue
                    }
                    ns_log notice "xorln_cf: solution item found qvar=$qvar_sol, w=$w"
                    set qwsum [expr {0.0 + $qwsum + $w * $qvar_sol}]
                    set qsum [expr {0.0 + $qsum + $qvar_sol}]
                }
            }

            set ratings $ratings_valid
            if {$qsum <= 0} {
                set qsum 0.001
                ns_log notice "####serious bug? xolrn_cf: important: qsum was 0!"
            }

            set evar [expr {(1.0 / $qsum) * $qwsum}]
            ns_log notice "xolrn_cf: qwsum fuer $item= $qwsum, qsum=$qsum, evar=$evar"

            $item set_property -new 1 evar $evar
            set bvar [$item get_property -name bvar]
            set nratings [llength $ratings]
            set qvar [expr {($answerstorate/($answerstorate+$nratings))*$bvar+(($nratings)/($nratings+$answerstorate)*$evar)}]
            ns_log notice "xolrn_cf: debug: bvar=$bvar evar=$evar nratings=$nratings answerstorate=$answerstorate - qvar=$qvar"
            $item set_property -new 1 ratings $ratings
            $item set_property -new 1 qvar $qvar

            set s [$item find_slot instance_attributes]
            $item update_attribute_from_slot -revision_id "[$item revision_id]" $s [$item instance_attributes]
            $item save
        }
    }

    AssignmentCoreWFprocs instproc save_values {} {
        foreach group [:get_property -name groups] {
            if {![string is integer $group]} {
                :set_property groups ""
                break
            }
        }
    }

    AssignmentCoreWFprocs instproc germanize_date {date} {
        set datevar [:get_property -name $date]
        return [lc_time_fmt $datevar {%d.%m.%Y %H:%M}]
    }

    ##########  Assignment Task Rendering: teachers view
    AssignmentCoreWFprocs instproc render_angabe_full {
      {-prefetch ""}
    } {
        ::xo::Page requireJS "/resources/tlf-assignments/tlf-assignment.js"
        ::xo::Page requireCSS "/resources/tlf-assignments/tlf-assignments.css"

        #Statusanzeige:
        set is_enabled [expr {[:check_submittable 0] eq "" ? 0 : 1}]
        if {${:state} ne "published"} {
            set is_enabled 0
        }
        set aufgabenstellung "
            <div class='submission-title'>
            <ul class='horizontal-list render-angabe'>
            <li><a href='[:pretty_link]'>${:title}</a></li>"
        if {$is_enabled} {
            append aufgabenstellung "<li><span class='notice n8 grey percent85' title='[_ tlf-assignments.is_running_help]'>[_ tlf-assignments.is_running]</span></li>"
        } else {
            if {${:state} eq "editing" || ${:state} eq "assign" || ${:state} eq "initial"} {
                append aufgabenstellung "<li><span class='notice n5 grey percent85' title='[_ tlf-assignments.draft_help]'>[_ tlf-assignments.draft]</span></li>"
            } elseif {${:state} eq "published"} {
                if {[clock seconds] > [clock scan [:get_property -name time_to]]} {
                    append aufgabenstellung  "<li><span class='notice n9 grey percent85' title='[_ tlf-assignments.time_up_help]'>[_ tlf-assignments.time_up]</span></li>"
                } else {
                    append aufgabenstellung "<li><span class='notice n7 grey percent85' title='[_ tlf-assignments.ready_help]'>[_ tlf-assignments.ready]</span></li>"
                }
            }
        }
        append aufgabenstellung  "
            <li><span style='font-weight:normal;'>[_ tlf-assignments.start]: [:germanize_date time_from] - [_ tlf-assignments.end]: [:germanize_date time_to]</span></li></ul></div>"

        # Cookie information re Aufgabendetails collapsed or expanded
        set collapseAufgabendetails_p [ad_get_cookie -include_set_cookies t "Aufgabendetails-toggle" 0 ]
        if {[ad_get_cookie -include_set_cookies t "Aufgabendetails-toggle" 0 ] == 0} {
            set ShowButton "display:none;"
            set HideButton ""

        } else {
            set ShowButton ""
            set HideButton "display:none;"
        }
        append aufgabenstellung "
                <div id='aufgabenstellung'>
                    <div id='aufgabendetails'>
                        <div style='padding:1em;'>
                        <div class='table'>
                                <div class='colgroup left'></div>
                                <div class='colgroup'></div>"
        if {[:get_property -name verbergen] eq ""} {
            append aufgabenstellung "<div class='tr'>
                                <div class='td left'>[_ tlf-assignments.visibility]:&nbsp;</div>
                                <div class='td'>[_ tlf-assignments.immer]</div>
                            </div>"
        } else {
            append aufgabenstellung "<div class='tr'>
                                <div class='td left'>[_ tlf-assignments.visibility]:&nbsp;</div>
                                <div class='td'> [_ tlf-assignments.visibility_help]</div>
                            </div>"
        }
        GradingType=[:get_property -name modus] create [self]::gtype
        set modus [[self]::gtype PrettyName ${:item_id}]

        append aufgabenstellung "<div class='tr'>
                                <div class='td left'>[_ tlf-assignments.grade_mode]:&nbsp;</div>
                                <div class='td' id='modus'>$modus</div>
                            </div>"
        if {[:get_property -name points] ne ""} {
            append aufgabenstellung "<div class='tr'>
                                <div class='td left'>[_ tlf-assignments.points]:&nbsp;</div>
                                <div class='td'> [:get_property -name points]</div>
                            </div>"
        }
        if {[set exam [:get_property -name examselector]] ne ""} {
            set examtitle [::xo::dc get_value title "select lr_title from lr_objects where lr_object_id = :exam" 0]
            append aufgabenstellung "<div class='tr'>
                        <div class='td left'>[_ tlf-assignments.exam]:&nbsp;</div>
                        <div class='td'>$examtitle </div>
                    </div>"
        }
        append aufgabenstellung "<div class='tr'>
                                <div class='td left'>[_ tlf-assignments.grade_release]:&nbsp;</div>
                                <div class='td'>"
        switch [:get_property -name beurteilung] {
            sofort {
                append aufgabenstellung "[_ tlf-assignments.rel_sofort]"
            }
            date {
                append aufgabenstellung "[:germanize_date release_date]"
            }
            korrektur {
                append aufgabenstellung "[_ tlf-assignments.rel_corr]"
            }
            keine {
                append aufgabenstellung "[_ tlf-assignments.none]"
            }
            individual {
                append aufgabenstellung "[_ tlf-assignments.individual]"
            }
        }
        append aufgabenstellung "</div>
                            </div>
                            <div class='tr'><div class='td'>&nbsp;</div></div>"
        append aufgabenstellung "<div class='tr'>
                                <div class='td left'>[_ tlf-assignments.text]:&nbsp;</div>
                                <div class='td'>[:get_property -name text]</div>
                            </div>"
        for {set f 1} {$f <= 5} {incr f} {
            set file [:get_property -name ss${f}]
            set name [join [::tlf_cassignments::get_from_value -value $file -attribute name $file]]
            set revision_id [::tlf_cassignments::get_from_value -value $file -attribute revision_id ""]
            if {$revision_id ne ""} {set revision_id "&revision_id=$revision_id"}
            if {$file ne ""} {
                append aufgabenstellung "<div class='tr'>
                                <div class='td left'>[_ tlf-assignments.attachment] $f:&nbsp;</div>
                                <div class='td'><a href='[:pretty_link -download 1]/ss${f}?filename=[ns_urlencode $name]$revision_id'>$name</a></div>
                            </div>"
            }
        }
        if {[:get_property -name _description] ne ""} {
            append aufgabenstellung "<div class='tr'>
                                <div class='td left'>[_ tlf-assignments.add_inf]:&nbsp;</div>
                                <div class='td'>[:get_property -name _description]</div>
                            </div>"
        }

        set member_names ""
        set group_names ""
        set bearb [:get_property -name bearbeiter -default ""]
        foreach gr [:get_property -name groups -default ""] {
            append group_names "<a href='groupmgr?a=view_detail&id=$gr&return_url=[::xo::cc set url]'>[::xo::dc get_value group_name {select group_name from groups where group_id = :gr} unbekannt]</a>, "
        }
        set group_names [string trimright $group_names ", "]

        foreach member $bearb {
            append member_names "[::tlf_cassignments::get_user_name -user_id $member], "
        }
        set member_names [string trimright $member_names ", "]
        if {$group_names ne ""} {
            append aufgabenstellung "<div class='tr'><div class='td'>&nbsp;</div></div>
                                    <div class='tr'>
                                        <div class='td left'>[_ tlf-assignments.assigned_members]:&nbsp;</div>
                                        <div class='td'> $group_names</div>
                                    </div>"
        } elseif {$member_names ne ""} {
            append aufgabenstellung "<div class='tr'><div class='td'>&nbsp;</div></div>
                                    <div class='tr'>
                                        <div class='td left'>[_ tlf-assignments.assigned_members]:&nbsp;</div>
                                        <div class='td'> $member_names</div>
                                    </div>"
        } else {
            append aufgabenstellung "<div class='tr'><div class='td'>&nbsp;</div></div>
                                    <div class='tr'>
                                        <div class='td left'>[_ tlf-assignments.assigned_members]:&nbsp;</div>
                                        <div class='td'> [_ tlf-assignments.alle]</div>
                                    </div>"
        }
        append aufgabenstellung "</div>
                            </div>
                            </div>
                         </div>"
        append aufgabenstellung "<div class='submission-title'>[_ tlf-assignments.abgaben_filter]:</div>
                                <div style='padding:1em 0;margin-bottom:1em;'>
                                    [:pp_calc_submissions -prefetch $prefetch]
                                </div>
                                <div style='clear:both;'></div>"

        return $aufgabenstellung
    }


    ##########  Assignment Task Rendering: students view
    AssignmentCoreWFprocs instproc render_angabe {} {
        set amiadmin [permission::permission_p -object_id ${:package_id} -privilege "admin"]
        #Statusanzeige:
        set is_enabled [expr {[:check_submittable 0] eq "" ? 0 : 1}]
        if {${:state} ne "published"} {
            set is_enabled 0
        }

        ::xo::Page requireCSS "/resources/tlf-assignments/tlf-assignments.css"
         set aufgabenstellung "
            <div class='submission-title'>
                <ul class='horizontal-list render-angabe'>
                    <li>"
        if {$amiadmin} {
            append aufgabenstellung "<a href='[:pretty_link]'>${:title}</a>"
        } else {
            append aufgabenstellung "${:title}"
        }
        append aufgabenstellung "</li>"
        if {$is_enabled} {
            append aufgabenstellung "<li><span class='notice-3fields n29 grey percent85' title='[_ tlf-assignments.is_running_help]'>[_ tlf-assignments.is_running]</span></li>"
        } else {
            if {${:state} eq "published"} {
                if {[clock seconds] > [clock scan [:get_property -name time_to]]} {
                    append aufgabenstellung "<li><span class='notice-3fields n27 grey percent85' title='#tlf-assignments.time_up_help#'>#tlf-assignments.closed#</span></li>"
                } else {
                    append aufgabenstellung "<li><span class='notice-3fields n28 grey percent85' title='#tlf-assignments.ready_help#'>#tlf-assignments.ready#</span></li>"
                }
            } else {
                append aufgabenstellung "<li><span class='notice-3fields n27 grey percent85' title='#tlf-assignments.time_up_help#'>#tlf-assignments.closed#</span></li>"
            }
        }
        append aufgabenstellung "
        <li style='font-weight:normal;'>[_ tlf-assignments.start]: [:germanize_date time_from] - [_ tlf-assignments.end]: [:germanize_date time_to]</li>
                    </ul>
             </div>
             <div id='aufgabenstellung'>
                <div id='aufgabendetails'>
                    <div style='padding:1em;'>
                    <div class='table'>
                        <div class='colgroup left'></div>
                        <div class='colgroup'></div>
                        "
        set details ""
        append details "<div class='tr'>
                <div class='td left'>[_ tlf-assignments.grade_release]:&nbsp;</div>
                <div class='td'>"
        switch [:get_property -name beurteilung] {
            sofort {
                append details "[_ tlf-assignments.rel_sofort]"
                }
            date {
                append details "[:germanize_date release_date]"
            }
            korrektur {
                append details "[_ tlf-assignments.rel_corr]"
            }
            keine {
                append details "[_ tlf-assignments.none]"
            }
            individual {
                append details "[_ tlf-assignments.individual]"
            }
        }
        append details "</div></div>"
        append details    "<div class='tr'><div class='td left'>[_ tlf-assignments.text]:&nbsp;</div>
                <div class='td'>[:get_property -name text]</div></div>"
        for {set f 1} {$f <= 5} {incr f} {
            set file [:get_property -name ss${f}]
            set name [join [::tlf_cassignments::get_from_value -value $file -attribute name $file]]
            set revision_id [::tlf_cassignments::get_from_value -value $file -attribute revision_id ""]
            if {$revision_id ne ""} {set revision_id "&revision_id=$revision_id"}
            if {$file ne ""} {
                append details "
                    <div class='tr'>
                        <div class='td left'>[_ tlf-assignments.attachment] $f:&nbsp;</div>
                        <div class='td'><a href='[:pretty_link -download 1]/ss${f}?filename=[ns_urlencode $name]$revision_id'>$name</a></div>
                    </div>"
            }
        }
        if {[:get_property -name _description] ne ""} {
            append details "
                <div class='tr'>
                    <div class='td left'>[_ tlf-assignments.add_inf]:&nbsp;</div>
                    <div class='td'>[:get_property -name _description]</div>
                </div>"
        }

        if {[:get_property -name verbergen] eq 1} {
            if {[clock seconds] > [clock scan [:get_property -name time_from]]} {
                append aufgabenstellung $details
            }
        } elseif {$amiadmin} {
            append aufgabenstellung $details
        } else {
            append aufgabenstellung $details
        }

        set group_names ""
        foreach gr [:get_property -name groups -default ""] {
            set is_member [group::member_p -user_id [::xo::cc set user_id] -group_id $gr -cascade]
            if {$is_member} {
                append group_names "[::xo::dc get_value group_name {select group_name from groups where group_id = :gr} unbekannt] "
                #list the members of :group
                set comm_id [dotlrn_community::get_community_id]
                set active_group_members ""
                foreach member [group::get_members -group_id $gr] {
                    if {[dotlrn_community::get_member_role $comm_id $member] ne ""} {
                        append active_group_members [::tlf_cassignments::get_user_name -user_id $member]
                        append active_group_members ", "
                    }
                }
                set active_group_members [string trimright $active_group_members ", "]
                append group_names "($active_group_members), "

            } else {
                append group_names "[::xo::dc get_value group_name {select group_name from groups where group_id = :gr} unbekannt], "
            }
        }
        set group_names [string trimright $group_names ", "]
        if {$group_names ne ""} {
            append aufgabenstellung " <div class='tr'>
                <div class='td left'>[_ tlf-assignments.assigned_members]: </div>
                <div class='td'>$group_names</div>
            </div>"
        }
        append aufgabenstellung "
                </div>
            </div>
            </div>
        </div>"
        return $aufgabenstellung
    }

    ##########  Assignment OT: Render Intro-Text for students
    AssignmentCoreWFprocs instproc render_intro_text {} {
        set intro_text "
                    <div class='netiquette'><p class='bold'>[_ tlf-assignments.ot_intro_text1]</p>
                    <ul><li>[_ tlf-assignments.ot_intro_text2]</li>
                    <li>[_ tlf-assignments.ot_intro_text3]</li>
                    <li><span class='bold'>[_ tlf-assignments.ot_intro_text4]</span></li>
                    </ul>
                    <p>[_ tlf-assignments.ot_intro_text5]</p>
                    </div>"
        return $intro_text
    }

    AssignmentCoreWFprocs instproc fristen {ast} {
        set html ""
        set group_id [:checkgroup [::xo::cc user_id]]
        set nf [$ast get_property -name [lindex $group_id 1]_nachfrist]
        if {$nf ne "" || [:get_property -name resubmissionff] ne ""} {
            append html "<div class='fristen'>
                            <div class='table'>"
            if {$nf ne ""} {
                append html "<div class='tr'><div class='td'>[_ tlf-assignments.nachfrist]:&nbsp;</div><div class='td'>[$ast germanize_date [lindex $group_id 1]_nachfrist] </div></div>"
            }
            if {[set resub [:get_property -name resubmissionff]] ne ""} {
                append html "<div class='tr'><div class='td'>[_ tlf-assignments.resub_deadline]:&nbsp;</div><div class='td'>[:germanize_date resubmissionff]</div></div>"
            }
            append html "</div></div>"
        }
        return $html
    }

    AssignmentCoreWFprocs instproc www-csv_export_ot {} {
        package require csv
        set csv ""
        set item_id ${:item_id}
        set parent_id [:parent_id]
        append csv [::csv::join [list matnr qvar bvar evar \
                        rateitem1_scale rateitem2_scale rateitem3_scale ratings ldist supervisorcomment \
                        group_name] ";"]
        append csv "\n"
        ::xo::dc foreach result {select
            (bt.hkey->'qvar')::text as qvar,
            (bt.hkey->'bvar')::text as bvar,
            (bt.hkey->'evar')::text as evar,
            (bt.hkey->'rateitem1_scale')::text as rateitem1_scale,
            (bt.hkey->'rateitem2_scale')::text as rateitem2_scale,
            (bt.hkey->'rateitem3_scale')::text as rateitem3_scale,
            (bt.hkey->'ratings')::text as ratings,
            (bt.hkey->'ldist')::text as ldist,
            (bt.hkey->'grade')::text as grade,
            (bt.hkey->'supervisorcomment')::text as supervisorcomment,
            (bt.hkey->'group_id')::text as group_id,
            group_name
            from xowiki_form_instance_item_index bt
            left outer join groups on (bt.hkey ->'group_id')::integer = groups.group_id
            where parent_id = :parent_id
            and (bt.hkey->'assignment_id')::integer = :item_id
            and (bt.hkey->'amiadmin')::boolean = false
        } {
            if {[acs_object_type $group_id] eq "group"} {
                ::xo::dc foreach group_member { select  trim(leading 'h' from a.username) as uname
                    from acs_users_all a, group_member_map gm
                    where gm.group_id = :group_id
                    and gm.member_id = a.user_id } {
                        append csv [::csv::join [list $uname $qvar $bvar $evar \
                        $rateitem1_scale $rateitem2_scale $rateitem3_scale $ratings $ldist $supervisorcomment \
                        $group_name] ";"]
                        append csv "\n"
                    }
            } elseif {[acs_object_type $group_id] eq "user"} {
                acs_user::get -user_id $group_id -array userinfo
                append csv [::csv::join [list $userinfo(username) $qvar $bvar $evar \
                        $rateitem1_scale $rateitem2_scale $rateitem3_scale $ratings $ldist $supervisorcomment] ";"]
                append csv "\n"
            }
        }
        if {$csv eq ""} {
            util_user_message  -message "[_ tlf-assignments.export_noting]"
            ad_returnredirect [${:package_id} pretty_link -parent_id [${:package_id} folder_id] index]
            ad_script_abort
        } else {
            ns_set update [ns_conn outputheaders] content-disposition [subst {attachment; filename="${:title}.csv"}]
            ns_return 200 text/csv $csv
            ad_script_abort
        }
    }
    AssignmentCoreWFprocs instproc www-csv_export {} {
        package require csv
        set item_id ${:item_id}
        set csv ""
        set package_id ${:package_id}
        set parent_id [$package_id set folder_id]
        if {[::xo::cc query_parameter all] eq 1} {
        #we want to export all members, including those without grades
            set comm_id [dotlrn_community::get_community_id]
            ::xo::dc foreach member {select  trim(leading 'h' from username) as uname from acs_users_all u where user_id in
                ( select user_id from dotlrn_member_rels_approved d
                    WHERE d.community_id in (select community_id from dotlrn_community_applets where package_id = :package_id)
                    AND d.rel_type IN ('dotlrn_student_rel','dotlrn_member_rel')
                    except (select
                        (bt.hkey->'group_id')::integer from xowiki_form_instance_item_index bt
                            where bt.package_id = :package_id
                        and (bt.hkey->'assignment_id')::integer = :item_id)
                ) order by 1 asc} {
                append csv "$uname;\n"
            }
        }
        ::xo::dc foreach result {select trim(leading 'h' from a.username) as uname ,
        (bt.hkey->'grade')::text as grade,
        (bt.hkey->'supervisorcomment')::text as supervisorcomment,
        (bt.hkey ->'group_id')::integer as group_id
        from xowiki_form_instance_item_index bt, acs_users_all a
        where parent_id = :parent_id
        and (bt.hkey->'assignment_id')::integer = :item_id
        and (bt.hkey->'graded')::integer = 1
        and (bt.hkey->'amiadmin')::boolean = false
        and a.user_id = coalesce( nullif((bt.hkey->'foreign_user')::integer, 0), (bt.hkey->'creator_id')::integer);} {
            if {[::xo::dc get_value is_group "select 1 from groups where
            group_id = :group_id" 0]} {
                ::xo::dc foreach group_member { select  trim(leading 'h' from a.username) as uname
                    from acs_users_all a, group_member_map gm
                    where gm.group_id = :group_id
                    and gm.member_id = a.user_id } {
                        if {[lc_get "decimal_point"] eq ","} {
                            regsub "\\." $grade "," grade
                        }
                        append csv [::csv::join [list $uname $grade $supervisorcomment] ";"]
                        append csv "\n"
                    }
            } else {
                if {[lc_get "decimal_point"] eq ","} {
                    regsub "\\." $grade "," grade
                }
                append csv [::csv::join [list $uname $grade $supervisorcomment] ";"]
                append csv "\n"
            }
        }
        if {$csv eq ""} {
              util_user_message  -message "[_ tlf-assignments.export_noting]"
              ad_returnredirect [${:package_id} pretty_link -parent_id [${:package_id} folder_id] index]
              ad_script_abort
        } else {
            ns_set update [ns_conn outputheaders] content-disposition [subst {attachment; filename="${:title}.csv"}]
            ns_return 200 text/csv $csv
            ad_script_abort
        }
    }

    AssignmentCoreWFprocs instproc -deprecated csv_export {args} {
        ad_log warning "????? Who calls me?"
        :www-csv_export {*}$args
    }

    ###########################################
    # collecting old revisions
    ###########################################
     AssignmentCoreWFprocs instproc collect_submissions {} {
        return "<div style='clear:both;margin-bottom:1em;'>
            [:get_property -name submission_log]
            </div>"
    }

    ###########################################
    # indexing proc for search
    ###########################################
    AssignmentCoreWFprocs instproc search_render {} {
        #ns_log notice "ast debug: ${:revision_id} is assignment, no indexing"
        return [list title "" html "" keywords ""]
    }

    AssignmentCoreWFprocs instproc www-unassign_group {} {
        set grouplist ""
        set remove_me [::xo::cc query_parameter group_id]
        foreach group [:get_property -name groups] {
            if {$group ne $remove_me} {
                lappend grouplist $group
            }
        }
        :set_property groups $grouplist
        :save
        ${:package_id} returnredirect [:query_parameter "return_url"]
    }

    AssignmentCoreWFprocs instproc trigrams2 string {
        #from http://wiki.tcl.tk/3841
        set rez [list]
        set str " $string "
        set l [expr {[string length $str]-2}]
        for {set x 0} {$x<$l} {incr x} {
            lappend rez [string range $str $x $x+2]
        }
        return $rez
    }

    AssignmentCoreWFprocs instproc similarity {str1 str2} {
        #from http://wiki.tcl.tk/3841
        set l1 [lsort -unique [:trigrams2 $str1]]
        set l2 [lsort -unique [:trigrams2 $str2]]
        set g 0
        set i1 0
        set i2 0
        set len1 [llength $l1]
        set len2 [llength $l2]
        set t1 [lindex $l1 $i1]
        set t2 [lindex $l2 $i2]
        set l 0
        while {$i1<$len1 && $i2<$len2} {
            incr l
            set r [string compare $t1 $t2]
            # better than switch statement
            if {$r==0} {
                incr i1
                set t1 [lindex $l1 $i1]
                incr i2
                set t2 [lindex $l2 $i2]
                incr g
            } elseif {$r==-1} {
                incr i1
                set t1 [lindex $l1 $i1]
            } else {
                incr i2
                set t2 [lindex $l2 $i2]
            }
        }
        expr {100*$g/$l}
    }

    AssignmentCoreWFprocs instproc www-release_grade {} {
        :set_property -new 1 grade_released 1
        :save
        ${:package_id} returnredirect [:query_parameter "return_url"]
    }

    AssignmentCoreWFprocs instproc is_unprefixed {} {
        return 1
    }

    AssignmentCoreWFprocs instproc edit_time_can_be_used_for_item {} {
        return 1
    }

    AssignmentCoreWFprocs instproc has_view_submissions {} {
        return 1
    }
}
Class create ButtonCancelMixin
ButtonCancelMixin instproc render_form_action_buttons {args} {
    if {${:state} eq "submitted"} {
        next
    } elseif {${:state} eq "initial"} {
        ::html::div -class "save-cancel" {
            next
            ::html::div -class "btn btn-link cancel" {
                ::html::a -href [:pretty_link]?m=delete {
                    ::html::t "[_ tlf-assignments.cancel]"
                }
            }
        }
    } else {
        ::html::div -class "save-cancel" {
            next
            ::html::div -class "btn btn-link cancel" {
                set package_id [::xo::cc set package_id]
                ::html::a -href [$package_id pretty_link -parent_id [$package_id folder_id] index] {
                    ::html::t "[_ tlf-assignments.navi_back]"
                }
            }
        }
    }
}

namespace eval ::xo::role {
    Role create tlf_ast_group_stud
    tlf_ast_group_stud proc is_member {-user_id:required -package_id} {
        if {[namespace which ::dotlrn_community::get_community_id] ne ""} {
            set community_id [:cache [list [dotlrn_community::get_community_id -package_id $package_id]]]
            if {$community_id ne ""} {
                return [:cache [list dotlrn::user_is_community_member_p \
                                  -user_id $user_id \
                                  -community_id $community_id]]
            }
        }
        return 0
    }
    tlf_ast_group_stud proc get_members {-object_id:required} {
        set community_id [dotlrn_community::get_community_id]
        set applet_key [ast_installer::applet_key]
        set package_id [::xo::cc set package_id]
        set members [::xo::dc list_of_lists -prepare integer,integer,text get_students {
            select p.last_name || ', ' || p.first_names || '; ' || u.username as title,
            u.user_id
            FROM acs_rels r,
            acs_rel_types rt,
            membership_rels mr,
            users u,
            persons p,
            acs_rel_roles role
            where r.object_id_one in (select community_id
                                      from dotlrn_community_applets
                                      where active_p = 't'
                                      and package_id = :package_id
                                      and applet_id = (select applet_id from dotlrn_applets
                                                       where applet_key = :applet_key)
                                      )
            and u.user_id = p.person_id
            and mr.rel_id = r.rel_id
            and u.user_id = r.object_id_two
            and rt.rel_type = r.rel_type
            and role.role = rt.role_two
            and mr.member_state = 'approved'
            and rt.role_two in ('student', 'member')
            order by last_name asc
        }]
        return $members
    }
}

::xo::library source_dependent
