##::xo::db::require package xowf
::xo::library require -package xowf xowf-procs


namespace eval ::xowf {
    Class create ::xowf::AssignmentSubmissionState
    ####################################
    # State initial
    ####################################
    AssignmentSubmissionState instproc abgabe_initial {name} {
        #initial state of a student's submission
        ::xo::Page requireJS "/resources/tlf-assignments/tlf-assignment.js"
        ::xo::Page requireCSS "/resources/tlf-assignments/tlf-assignments.css"
        set obj ${:object}
        set ast [::xo::db::CrClass get_instance_from_db -item_id [:property assignment_id]]
        set abgabe "[_ tlf-assignments.subm]"
        if {[$obj get_property -name resubmissionff] ne ""} {
            set resub "@resubmissionff@"
        } else {
            set resub ""
        }
        SubmissionType=[$obj get_property -name exercise_form] create [self]::stype
        array set forminfo [[self]::stype form_info $obj $ast]
        set group [lindex [$ast checkgroup [::xo::cc user_id]] 1]
        #render header and nachfrist
        set amiadmin [permission::permission_p -object_id [$ast set package_id] -privilege "admin"]
        set foreign_user [expr {[$obj get_property -name foreign_user] eq "" ? [::xo::cc query_parameter user_id] : [$obj get_property -name foreign_user]}]
        if {$foreign_user eq ""} {set foreign_user 0}
        if {$amiadmin &&  $foreign_user} {
            append html "<div class='netiquette'>#tlf-assignments.submit_as_student_nag# [::tlf_cassignments::get_user_name -user_id $foreign_user].</div>"
        
        } elseif {$amiadmin} {
            append html "<div class='netiquette'>#tlf-assignments.test_nag#</div>"
        }
        if {[$obj get_property -name exercise_form] eq "ot"} {
            append html "[$ast render_intro_text]"
        }
        append html "[$ast render_angabe]"
        append html [$obj fristen $ast]
        set nf [$ast get_property -name ${group}_nachfrist]
        append html "</div>"

        #allow the student to write a comment for all forms except exam
        if {[$ast get_property -name exercise_form] ne "exam"} {
            set commenthtml "@comment@</p>"
        } else {
            set commenthtml ""
        }

        #collect old submissions
        set collected_submissions  "<div>[$obj collect_submissions]</div>"
        #if {$collected_submissions ne ""} {:set_property -new 1 comment ""}
        set form [::xowiki::Form new -childof [self] -name en:abgabe_initial\
            -form "<form class='edit-mode-abgabe'>
                        $html
                        $collected_submissions
                        <div class='submission-title'>$abgabe</div>
                        <div class='edit-mode'>
                            $forminfo(subm)
                            $commenthtml
                            $resub
                            @_creator@
                            @group_id@
                            @assignment_id@
                            $forminfo(form_info_final)
                        </div>
                    </form>
                " \
            -anon_instances t -form_constraints [subst {
                 $forminfo(fc)
                @cr_fields:hidden
                group_id:hidden
                {answer:richtext,
                    label=#tlf-assignments.my_ans#,
                    required=1,
                    rows=15,
                    validator=safe_html,
                    editor=ckeditor4,
                    toolbar=Minimal,
                    customConfig=/resources/tlf-assignments/ck_config_minimal.js,
                    extraPlugins=
                }
                {comment:textarea,label=#tlf-assignments.my_comment#}
                {supervisorcomment:label,label=#tlf-assignments.supercomment#}
                assignment_id:hidden
                resubmissionff:hidden
                {superfile:pretty_file,label=#tlf-assignments.superfile#,disabled}
            }]
        ]
        return $form
    }
    
    
    ##########################################
    # State submitted, resubmission, grade_state
    ##########################################
    AssignmentSubmissionState instproc abgabe_submitted {name} {
        #write a list of all submissions + feedback
        ::xo::Page requireJS "/resources/tlf-assignments/tlf-assignment.js"
        ::xo::Page requireCSS "/resources/tlf-assignments/tlf-assignments.css"
        set ast [::xo::db::CrClass get_instance_from_db -item_id [:property assignment_id]]
        set html ""
        set ffs ""
        set obj ${:object}
        set amiadmin [permission::permission_p -object_id [$obj set package_id] -privilege "admin"]

        if {$amiadmin} {
            set package_id [${:object} set package_id]
            set ast [::xo::db::CrClass get_instance_from_db -item_id [$obj get_property -name assignment_id]]
        }
        SubmissionType=[$obj get_property -name exercise_form] create [self]::stype
        array set submission_form_html [[self]::stype submission_form_html $obj $ast]
        if {[$obj get_property -name comment] ne ""} {
            append ffs "{comment:label,label=#tlf-assignments.subm_comm#}"
            append html "\n@comment@\n"
        }
        set form [::xowiki::Form new -childof [self] -name en:abgabe_initial\
            -form "<form class='non-edit-mode'>
                        [$ast render_angabe]
                        [$obj fristen $ast]
                        @_creator@
                        @group_id@
                        @assignment_id@
                        $submission_form_html(html)
                        $submission_form_html(ff)
                        $html
                    </form>
                " \
        -anon_instances t -form_constraints "
                {file1:pretty_file,label=#tlf-assignments.subm#,disabled}
                @cr_fields:hidden
                group_id:hidden
                $ffs
                assignment_id:hidden
                file2:pretty_file,disabled,label=
                file3:pretty_file,disabled,label=
                file4:pretty_file,disabled,label=
                file5:pretty_file,disabled,label=
                {page:richtext,disabled=1,label=#tlf-assignments.subm#}
                {answer:richtext,disabled=1,label=#tlf-assignments.my_ans#}
            "
        ]
        return $form
    }

    ##########################################
    # State grade_state
    ##########################################
    AssignmentSubmissionState instproc abgabe_grade {name} {
        #grading form
        ::xo::Page requireJS "/resources/tlf-assignments/tlf-assignment.js"
        ::xo::Page requireCSS "/resources/tlf-assignments/tlf-assignments.css"
        set ast [::xo::db::CrClass get_instance_from_db -item_id [:property assignment_id]]
        set gradehtml ""
        set grade_fc ""
        set link ""
        set obj ${:object}
        set id [$obj set item_id]
        set last_state [::xo::dc get_value -prepare integer last_state {
            select state from xowiki_form_page
            where xowiki_form_page_id = (select max(revision_id)
                                         from cr_revisions r, cr_items i
                                         where r.item_id = i.item_id
                                           and r.revision_id <> i.latest_revision
                                           and i.item_id = :id)
        }]
        if {$last_state ne "graded"} {
            $obj set_property -new 1 supervisorcomment ""
        }
            $obj set_property -new 1 superfile ""
        SubmissionType=[$obj get_property -name exercise_form] create [self]::stype
        array set type_vars [[self]::stype grading_form $obj]
        array set subm_vars [[self]::stype submission_form_html $obj $ast] 
        
        set bearbeitung ""
        if {[$obj get_property -name start_date] ne ""} {
            set bearbeitung "
                <div class='grey margin-bottom-1'>[_ tlf-assignments.bzeit]: [$obj get_property -name start_date] - [$obj get_property -name end_date]</div>
            "
        }
        GradingType=[$ast get_property -name modus] create [self]::gtype
        set grade_fc [[self]::gtype formConst $ast]
        set form [::xowiki::Form new -childof [self] -name en:abgabe_initial\
            -form "<form class='edit-mode-abgabe'>
                [$ast render_angabe]
                [$obj fristen $ast]
                $bearbeitung
                $subm_vars(html)
                $subm_vars(ff)
                @_creator@
                @group_id@
                @assignment_id@
                <div class='edit-mode margin-top-1'>
                $type_vars(form)
                $gradehtml
                </div>
                </form>
            " \
            -anon_instances t -form_constraints "
                {file1:pretty_file,label=#tlf-assignments.subm#,disabled}
                @cr_fields:hidden
                group_id:hidden
                comment:label,label=#tlf-assignments.comment#
                assignment_id:hidden
                file2:pretty_file,disabled,label=
                file3:pretty_file,disabled,label=
                file4:pretty_file,disabled,label=
                file5:pretty_file,disabled,label=
                $grade_fc
                $type_vars(ff)"
        ]
        return $form
    }
    
    ##########################################
    # State graded
    ##########################################
    AssignmentSubmissionState instproc abgabe_graded {name} {
        #submission has been graded
        ::xo::Page requireJS "/resources/tlf-assignments/tlf-assignment.js"
        ::xo::Page requireCSS "/resources/tlf-assignments/tlf-assignments.css"
        set link ""
        set obj ${:object}
        set amiadmin [permission::permission_p -object_id [$obj set package_id] -privilege "admin"]
        if {$amiadmin} {
            set package_id [$obj set package_id]
            set ast [::xo::db::CrClass get_instance_from_db -item_id [:get_property -name assignment_id]]
        }
        set ast [::xo::db::CrClass get_instance_from_db -item_id [:property assignment_id]]
        set ff ""
        if {[$obj get_property -name supervisorcomment] ne ""} {
            append ff "{supervisorcomment:label,label=#tlf-assignments.supercomment#}\n"
        } else {
            append ff "supervisorcomment:hidden\n"
        }
        if {[$obj get_property -name comment] ne ""} {
            append ff "{comment:label,label=#tlf-assignments.comment#}\n"
        } else {
            append ff "comment:hidden\n"
        }
        SubmissionType=[$obj get_property -name exercise_form] create [self]::stype
        array set graded_form_info [[self]::stype graded_form_html $obj $ast]
        GradingType=[$ast get_property -name modus] create [self]::gtype
        set modus [[self]::gtype PrettyName $ast]
        set stud [$obj get_property -name creator_id]
        set uname [::tlf_cassignments::get_user_name -user_id $stud]
        set submission_date [$obj get_property -name  submission_date]
        set submission_date_clean "" 
        set beurteiler [$obj get_property -name beurteiler]
        if {$beurteiler ne ""} {
            set beurteiler [::tlf_cassignments::get_user_name -user_id $beurteiler]
        }
        set grading_date [$obj get_property -name grading_date]
        if {$grading_date ne ""} {
            set grading_date [clock format $grading_date -format  {%d.%m.%Y %H:%M}]
        }
        if {[$ast check_grade_vis] || $amiadmin} {
            set conditionals "@grade@ @superfile@ @supervisorcomment@"
        } else {
            set conditionals ""
        }
        set bearbeitung ""
        if {[$obj get_property -name start_date] ne ""} {
            set bearbeitung "
                <div class='grey margin-bottom-1'>Bearbeitungszeitraum: [$obj get_property -name start_date] - [$obj get_property -name end_date]</div>
            "
        }
        catch {set submission_date_clean [clock format $submission_date -format  {%d.%m.%Y %H:%M}]} err
        set form [::xowiki::Form new -childof [self] -name en:abgabe_initial\
            -form "<form class='non-edit-mode'>
                    [$ast render_angabe]
                    [$obj fristen $ast]
                    [$obj collect_submissions]
                    <div class='submission-title'>#tlf-assignments.subm# $submission_date_clean</div>
                    <div class='submitter'>$uname</div>
                    $bearbeitung
                    $graded_form_info(link)
                    @comment@
                    <br>
                    <div class='submission-title'>#tlf-assignments.grading# $grading_date</div>
                    <div class='submitter'>$beurteiler</div>
                        @mode@
                        $conditionals
                        @_creator@
                        @group_id@
                        @assignment_id@
                    </form>
            " \
            -anon_instances t -form_constraints "
                {file1:pretty_file,disabled,label=}
                @cr_fields:hidden
                  group_id:hidden
                  {mode:label,value=$modus,label=#tlf-assignments.grade_mode#}
                  assignment_id:hidden
                  file2:pretty_file,disabled,label=
                  file3:pretty_file,disabled,label=
                  file4:pretty_file,disabled,label=
                  file5:pretty_file,disabled,label=
                  grade:subst_label,label=#tlf-assignments.grading#
                  superfile:pretty_file,disabled,label=
                  $graded_form_info(ff)"
        ]
        return $form
    }

    ############################################
    # State resubmission
    ############################################
    AssignmentSubmissionState instproc abgabe_resubmission {name} {
        #resubmission form
        set obj ${:object}
        ::xo::Page requireJS "/resources/tlf-assignments/tlf-assignment.js"
        ::xo::Page requireCSS "/resources/tlf-assignments/tlf-assignments.css"
        set ast [::xo::db::CrClass get_instance_from_db -item_id [:property assignment_id]]
        set additional_ff ""
        SubmissionType=[$obj get_property -name exercise_form] create [self]::stype
        array set submission_form_html [[self]::stype submission_form_html $obj $ast]
        #reset comments
        $obj set_property -new 1 superfile ""
        $obj set_property -new 1 supervisorcomment ""
        if {[::xo::cc permission -object_id [::xo::cc set package_id] -privilege admin -party_id [::xo::cc user_id]]} {
            append additional_ff " 
                @resubmissionff@
                @supervisorcomment@
                @superfile@
                "
        }
        set form [::xowiki::Form new -childof [self] -name en:abgabe_initial\
            -form "<form class='edit-mode-abgabe'>
                        [$ast render_angabe]
                        [$obj fristen $ast]
                        @_creator@
                        @group_id@
                        @assignment_id@
                        $submission_form_html(html)
                        $submission_form_html(ff)
                        @comment@<br>
                        <div class='submission-title'>#tlf-assignments.resub#</div>
                        <div class='edit-mode margin-top-1'>
                        $additional_ff
                        </div>
                    </form>
            " \
            -anon_instances t -form_constraints "
                @cr_fields:hidden
                group_id:hidden
                assignment_id:hidden
                {resubmissionff:date_with_widget,
		    format=DD_MONTH_YYYY_HH24_MI,
                    required=yes,
                    label=#tlf-assignments.deadline#}
                {superfile:pretty_file,label=#tlf-assignments.file_upload#}
                {supervisorcomment:textarea,label=#tlf-assignments.supercomment#,admin?:disabled}
                {file1:pretty_file,label=#tlf-assignments.subm#,disabled}
                file2:pretty_file,disabled,label=
                file3:pretty_file,disabled,label=
                file4:pretty_file,disabled,label=
                file5:pretty_file,disabled,label=
                {comment:label=#tlf-assignments.subm_comm#,label}
                {answer:richtext,disabled=1,label=Antwort}
                {page:richtext,disabled,label=#tlf-assignments.subm#}"
        ]
        return $form
    }

    ############################################
    # State rate (for opentext exercise)
    ############################################
    AssignmentSubmissionState instproc rating_form {name} {
        set ast [:get_property -name assignment_id]
        ::xo::db::CrClass get_instance_from_db -item_id $ast
        set group [lindex [$ast checkgroup [::xo::cc user_id]] 1]
        set html "[$ast render_intro_text]"
        append html [$ast render_angabe]
        set nf [$ast get_property -name ${group}_nachfrist]
        if {$nf ne ""} {
            append html "<br>#tlf-assignments.nachfrist#: $nf</div>"
        } else {
            append html "</div>"
        }
        set rate_text "#tlf-assignments.rate_help#"
        set f [::xowiki::Form new -childof [self] -name ot-rate -title "Please rate the answers below" \
            -text {} \
            -form [subst {{<form>
                $html
                <div class='table-wizard'>
                    <div class='tr'>
                        <div class='td grey'>[_ tlf-assignments.ot_step1] </div>
                        <div class='td active'>[_ tlf-assignments.ot_step2]</div>
                    </div>
                </div>
                <table>
                <colgroup> <col width="120" /> <col width="80" /> </colgroup>
                    <tbody>
                    <tr> <td style="width: 100%;">@rateitem1@ @rateitem1_scale@</td></tr>
                    <tr> <td>@rateitem2@ @rateitem2_scale@</td></tr>
                    <tr> <td>@rateitem3@ @rateitem3_scale@</td></tr>
                    </tbody> </table> </form>} text/html} ]\
            -anon_instances t \
            -form_constraints [subst {
                {rateitem1:richtext,label=#tlf-assignments.other_rating#,disabled=true}
                {rateitem1_scale:scale,n=10,label=#tlf-assignments.your_rating#,horizontal=true,\
                    required=yes,help_text=$rate_text}
                {rateitem2:richtext,label=#tlf-assignments.other_rating#,disabled=true}
                {rateitem2_scale:scale,n=10,label=#tlf-assignments.your_rating#,horizontal=true,\
                    required=yes,help_text=$rate_text}
                {rateitem3:richtext,label=#tlf-assignments.other_rating#,disabled=true}
                {rateitem3_scale:scale,n=10,label=#tlf-assignments.your_rating#,horizontal=true,\
                    required=yes,help_text=$rate_text}
                @cr_fields:hidden}]
        ]
        return $f
    }
}

::xo::library source_dependent
